<?php

namespace Sura\Services\Autoclick\ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfDeducibleBase ArrayType
 * Meta information extracted from the WSDL
 * - nillable: true
 * - type: tns:ArrayOfDeducibleBase
 * @subpackage Arrays
 */
class ArrayOfDeducibleBase extends AbstractStructArrayBase
{
    /**
     * The DeducibleBase
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var \Sura\Services\Autoclick\StructType\DeducibleBase[]
     */
    public $DeducibleBase;
    /**
     * Constructor method for ArrayOfDeducibleBase
     * @uses ArrayOfDeducibleBase::setDeducibleBase()
     * @param \Sura\Services\Autoclick\StructType\DeducibleBase[] $deducibleBase
     */
    public function __construct(array $deducibleBase = array())
    {
        $this
            ->setDeducibleBase($deducibleBase);
    }
    /**
     * Get DeducibleBase value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \Sura\Services\Autoclick\StructType\DeducibleBase[]|null
     */
    public function getDeducibleBase()
    {
        return isset($this->DeducibleBase) ? $this->DeducibleBase : null;
    }
    /**
     * This method is responsible for validating the values passed to the setDeducibleBase method
     * This method is willingly generated in order to preserve the one-line inline validation within the setDeducibleBase method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateDeducibleBaseForArrayConstraintsFromSetDeducibleBase(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $arrayOfDeducibleBaseDeducibleBaseItem) {
            // validation for constraint: itemType
            if (!$arrayOfDeducibleBaseDeducibleBaseItem instanceof \Sura\Services\Autoclick\StructType\DeducibleBase) {
                $invalidValues[] = is_object($arrayOfDeducibleBaseDeducibleBaseItem) ? get_class($arrayOfDeducibleBaseDeducibleBaseItem) : sprintf('%s(%s)', gettype($arrayOfDeducibleBaseDeducibleBaseItem), var_export($arrayOfDeducibleBaseDeducibleBaseItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The DeducibleBase property can only contain items of type \Sura\Services\Autoclick\StructType\DeducibleBase, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set DeducibleBase value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param \Sura\Services\Autoclick\StructType\DeducibleBase[] $deducibleBase
     * @return \Sura\Services\Autoclick\ArrayType\ArrayOfDeducibleBase
     */
    public function setDeducibleBase(array $deducibleBase = array())
    {
        // validation for constraint: array
        if ('' !== ($deducibleBaseArrayErrorMessage = self::validateDeducibleBaseForArrayConstraintsFromSetDeducibleBase($deducibleBase))) {
            throw new \InvalidArgumentException($deducibleBaseArrayErrorMessage, __LINE__);
        }
        if (is_null($deducibleBase) || (is_array($deducibleBase) && empty($deducibleBase))) {
            unset($this->DeducibleBase);
        } else {
            $this->DeducibleBase = $deducibleBase;
        }
        return $this;
    }
    /**
     * Add item to DeducibleBase value
     * @throws \InvalidArgumentException
     * @param \Sura\Services\Autoclick\StructType\DeducibleBase $item
     * @return \Sura\Services\Autoclick\ArrayType\ArrayOfDeducibleBase
     */
    public function addToDeducibleBase(\Sura\Services\Autoclick\StructType\DeducibleBase $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \Sura\Services\Autoclick\StructType\DeducibleBase) {
            throw new \InvalidArgumentException(sprintf('The DeducibleBase property can only contain items of type \Sura\Services\Autoclick\StructType\DeducibleBase, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->DeducibleBase[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \Sura\Services\Autoclick\StructType\DeducibleBase|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \Sura\Services\Autoclick\StructType\DeducibleBase|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \Sura\Services\Autoclick\StructType\DeducibleBase|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \Sura\Services\Autoclick\StructType\DeducibleBase|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \Sura\Services\Autoclick\StructType\DeducibleBase|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string DeducibleBase
     */
    public function getAttributeName()
    {
        return 'DeducibleBase';
    }
}
