<?php

namespace Sura\Services\Autoclick\ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfDeducibleCoberturaModel ArrayType
 * Meta information extracted from the WSDL
 * - nillable: true
 * - type: tns:ArrayOfDeducibleCoberturaModel
 * @subpackage Arrays
 */
class ArrayOfDeducibleCoberturaModel extends AbstractStructArrayBase
{
    /**
     * The DeducibleCoberturaModel
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var \Sura\Services\Autoclick\StructType\DeducibleCoberturaModel[]
     */
    public $DeducibleCoberturaModel;
    /**
     * Constructor method for ArrayOfDeducibleCoberturaModel
     * @uses ArrayOfDeducibleCoberturaModel::setDeducibleCoberturaModel()
     * @param \Sura\Services\Autoclick\StructType\DeducibleCoberturaModel[] $deducibleCoberturaModel
     */
    public function __construct(array $deducibleCoberturaModel = array())
    {
        $this
            ->setDeducibleCoberturaModel($deducibleCoberturaModel);
    }
    /**
     * Get DeducibleCoberturaModel value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \Sura\Services\Autoclick\StructType\DeducibleCoberturaModel[]|null
     */
    public function getDeducibleCoberturaModel()
    {
        return isset($this->DeducibleCoberturaModel) ? $this->DeducibleCoberturaModel : null;
    }
    /**
     * This method is responsible for validating the values passed to the setDeducibleCoberturaModel method
     * This method is willingly generated in order to preserve the one-line inline validation within the setDeducibleCoberturaModel method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateDeducibleCoberturaModelForArrayConstraintsFromSetDeducibleCoberturaModel(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $arrayOfDeducibleCoberturaModelDeducibleCoberturaModelItem) {
            // validation for constraint: itemType
            if (!$arrayOfDeducibleCoberturaModelDeducibleCoberturaModelItem instanceof \Sura\Services\Autoclick\StructType\DeducibleCoberturaModel) {
                $invalidValues[] = is_object($arrayOfDeducibleCoberturaModelDeducibleCoberturaModelItem) ? get_class($arrayOfDeducibleCoberturaModelDeducibleCoberturaModelItem) : sprintf('%s(%s)', gettype($arrayOfDeducibleCoberturaModelDeducibleCoberturaModelItem), var_export($arrayOfDeducibleCoberturaModelDeducibleCoberturaModelItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The DeducibleCoberturaModel property can only contain items of type \Sura\Services\Autoclick\StructType\DeducibleCoberturaModel, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set DeducibleCoberturaModel value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param \Sura\Services\Autoclick\StructType\DeducibleCoberturaModel[] $deducibleCoberturaModel
     * @return \Sura\Services\Autoclick\ArrayType\ArrayOfDeducibleCoberturaModel
     */
    public function setDeducibleCoberturaModel(array $deducibleCoberturaModel = array())
    {
        // validation for constraint: array
        if ('' !== ($deducibleCoberturaModelArrayErrorMessage = self::validateDeducibleCoberturaModelForArrayConstraintsFromSetDeducibleCoberturaModel($deducibleCoberturaModel))) {
            throw new \InvalidArgumentException($deducibleCoberturaModelArrayErrorMessage, __LINE__);
        }
        if (is_null($deducibleCoberturaModel) || (is_array($deducibleCoberturaModel) && empty($deducibleCoberturaModel))) {
            unset($this->DeducibleCoberturaModel);
        } else {
            $this->DeducibleCoberturaModel = $deducibleCoberturaModel;
        }
        return $this;
    }
    /**
     * Add item to DeducibleCoberturaModel value
     * @throws \InvalidArgumentException
     * @param \Sura\Services\Autoclick\StructType\DeducibleCoberturaModel $item
     * @return \Sura\Services\Autoclick\ArrayType\ArrayOfDeducibleCoberturaModel
     */
    public function addToDeducibleCoberturaModel(\Sura\Services\Autoclick\StructType\DeducibleCoberturaModel $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \Sura\Services\Autoclick\StructType\DeducibleCoberturaModel) {
            throw new \InvalidArgumentException(sprintf('The DeducibleCoberturaModel property can only contain items of type \Sura\Services\Autoclick\StructType\DeducibleCoberturaModel, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->DeducibleCoberturaModel[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \Sura\Services\Autoclick\StructType\DeducibleCoberturaModel|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \Sura\Services\Autoclick\StructType\DeducibleCoberturaModel|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \Sura\Services\Autoclick\StructType\DeducibleCoberturaModel|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \Sura\Services\Autoclick\StructType\DeducibleCoberturaModel|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \Sura\Services\Autoclick\StructType\DeducibleCoberturaModel|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string DeducibleCoberturaModel
     */
    public function getAttributeName()
    {
        return 'DeducibleCoberturaModel';
    }
}
