<?php

namespace Sura\Services\Autoclick\ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfDeducibleKilometro ArrayType
 * Meta information extracted from the WSDL
 * - nillable: true
 * - type: tns:ArrayOfDeducibleKilometro
 * @subpackage Arrays
 */
class ArrayOfDeducibleKilometro extends AbstractStructArrayBase
{
    /**
     * The DeducibleKilometro
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var \Sura\Services\Autoclick\StructType\DeducibleKilometro[]
     */
    public $DeducibleKilometro;
    /**
     * Constructor method for ArrayOfDeducibleKilometro
     * @uses ArrayOfDeducibleKilometro::setDeducibleKilometro()
     * @param \Sura\Services\Autoclick\StructType\DeducibleKilometro[] $deducibleKilometro
     */
    public function __construct(array $deducibleKilometro = array())
    {
        $this
            ->setDeducibleKilometro($deducibleKilometro);
    }
    /**
     * Get DeducibleKilometro value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \Sura\Services\Autoclick\StructType\DeducibleKilometro[]|null
     */
    public function getDeducibleKilometro()
    {
        return isset($this->DeducibleKilometro) ? $this->DeducibleKilometro : null;
    }
    /**
     * This method is responsible for validating the values passed to the setDeducibleKilometro method
     * This method is willingly generated in order to preserve the one-line inline validation within the setDeducibleKilometro method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateDeducibleKilometroForArrayConstraintsFromSetDeducibleKilometro(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $arrayOfDeducibleKilometroDeducibleKilometroItem) {
            // validation for constraint: itemType
            if (!$arrayOfDeducibleKilometroDeducibleKilometroItem instanceof \Sura\Services\Autoclick\StructType\DeducibleKilometro) {
                $invalidValues[] = is_object($arrayOfDeducibleKilometroDeducibleKilometroItem) ? get_class($arrayOfDeducibleKilometroDeducibleKilometroItem) : sprintf('%s(%s)', gettype($arrayOfDeducibleKilometroDeducibleKilometroItem), var_export($arrayOfDeducibleKilometroDeducibleKilometroItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The DeducibleKilometro property can only contain items of type \Sura\Services\Autoclick\StructType\DeducibleKilometro, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set DeducibleKilometro value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param \Sura\Services\Autoclick\StructType\DeducibleKilometro[] $deducibleKilometro
     * @return \Sura\Services\Autoclick\ArrayType\ArrayOfDeducibleKilometro
     */
    public function setDeducibleKilometro(array $deducibleKilometro = array())
    {
        // validation for constraint: array
        if ('' !== ($deducibleKilometroArrayErrorMessage = self::validateDeducibleKilometroForArrayConstraintsFromSetDeducibleKilometro($deducibleKilometro))) {
            throw new \InvalidArgumentException($deducibleKilometroArrayErrorMessage, __LINE__);
        }
        if (is_null($deducibleKilometro) || (is_array($deducibleKilometro) && empty($deducibleKilometro))) {
            unset($this->DeducibleKilometro);
        } else {
            $this->DeducibleKilometro = $deducibleKilometro;
        }
        return $this;
    }
    /**
     * Add item to DeducibleKilometro value
     * @throws \InvalidArgumentException
     * @param \Sura\Services\Autoclick\StructType\DeducibleKilometro $item
     * @return \Sura\Services\Autoclick\ArrayType\ArrayOfDeducibleKilometro
     */
    public function addToDeducibleKilometro(\Sura\Services\Autoclick\StructType\DeducibleKilometro $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \Sura\Services\Autoclick\StructType\DeducibleKilometro) {
            throw new \InvalidArgumentException(sprintf('The DeducibleKilometro property can only contain items of type \Sura\Services\Autoclick\StructType\DeducibleKilometro, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->DeducibleKilometro[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \Sura\Services\Autoclick\StructType\DeducibleKilometro|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \Sura\Services\Autoclick\StructType\DeducibleKilometro|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \Sura\Services\Autoclick\StructType\DeducibleKilometro|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \Sura\Services\Autoclick\StructType\DeducibleKilometro|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \Sura\Services\Autoclick\StructType\DeducibleKilometro|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string DeducibleKilometro
     */
    public function getAttributeName()
    {
        return 'DeducibleKilometro';
    }
}
