<?php

namespace Sura\Services\Autoclick\ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfFormaPago ArrayType
 * Meta information extracted from the WSDL
 * - nillable: true
 * - type: tns:ArrayOfFormaPago
 * @subpackage Arrays
 */
class ArrayOfFormaPago extends AbstractStructArrayBase
{
    /**
     * The FormaPago
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var \Sura\Services\Autoclick\StructType\FormaPago[]
     */
    public $FormaPago;
    /**
     * Constructor method for ArrayOfFormaPago
     * @uses ArrayOfFormaPago::setFormaPago()
     * @param \Sura\Services\Autoclick\StructType\FormaPago[] $formaPago
     */
    public function __construct(array $formaPago = array())
    {
        $this
            ->setFormaPago($formaPago);
    }
    /**
     * Get FormaPago value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \Sura\Services\Autoclick\StructType\FormaPago[]|null
     */
    public function getFormaPago()
    {
        return isset($this->FormaPago) ? $this->FormaPago : null;
    }
    /**
     * This method is responsible for validating the values passed to the setFormaPago method
     * This method is willingly generated in order to preserve the one-line inline validation within the setFormaPago method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateFormaPagoForArrayConstraintsFromSetFormaPago(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $arrayOfFormaPagoFormaPagoItem) {
            // validation for constraint: itemType
            if (!$arrayOfFormaPagoFormaPagoItem instanceof \Sura\Services\Autoclick\StructType\FormaPago) {
                $invalidValues[] = is_object($arrayOfFormaPagoFormaPagoItem) ? get_class($arrayOfFormaPagoFormaPagoItem) : sprintf('%s(%s)', gettype($arrayOfFormaPagoFormaPagoItem), var_export($arrayOfFormaPagoFormaPagoItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The FormaPago property can only contain items of type \Sura\Services\Autoclick\StructType\FormaPago, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set FormaPago value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param \Sura\Services\Autoclick\StructType\FormaPago[] $formaPago
     * @return \Sura\Services\Autoclick\ArrayType\ArrayOfFormaPago
     */
    public function setFormaPago(array $formaPago = array())
    {
        // validation for constraint: array
        if ('' !== ($formaPagoArrayErrorMessage = self::validateFormaPagoForArrayConstraintsFromSetFormaPago($formaPago))) {
            throw new \InvalidArgumentException($formaPagoArrayErrorMessage, __LINE__);
        }
        if (is_null($formaPago) || (is_array($formaPago) && empty($formaPago))) {
            unset($this->FormaPago);
        } else {
            $this->FormaPago = $formaPago;
        }
        return $this;
    }
    /**
     * Add item to FormaPago value
     * @throws \InvalidArgumentException
     * @param \Sura\Services\Autoclick\StructType\FormaPago $item
     * @return \Sura\Services\Autoclick\ArrayType\ArrayOfFormaPago
     */
    public function addToFormaPago(\Sura\Services\Autoclick\StructType\FormaPago $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \Sura\Services\Autoclick\StructType\FormaPago) {
            throw new \InvalidArgumentException(sprintf('The FormaPago property can only contain items of type \Sura\Services\Autoclick\StructType\FormaPago, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->FormaPago[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \Sura\Services\Autoclick\StructType\FormaPago|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \Sura\Services\Autoclick\StructType\FormaPago|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \Sura\Services\Autoclick\StructType\FormaPago|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \Sura\Services\Autoclick\StructType\FormaPago|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \Sura\Services\Autoclick\StructType\FormaPago|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string FormaPago
     */
    public function getAttributeName()
    {
        return 'FormaPago';
    }
}
