<?php

namespace Sura\Services\Autoclick\ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfOferta ArrayType
 * Meta information extracted from the WSDL
 * - nillable: true
 * - type: tns:ArrayOfOferta
 * @subpackage Arrays
 */
class ArrayOfOferta extends AbstractStructArrayBase
{
    /**
     * The Oferta
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var \Sura\Services\Autoclick\StructType\Oferta[]
     */
    public $Oferta;
    /**
     * Constructor method for ArrayOfOferta
     * @uses ArrayOfOferta::setOferta()
     * @param \Sura\Services\Autoclick\StructType\Oferta[] $oferta
     */
    public function __construct(array $oferta = array())
    {
        $this
            ->setOferta($oferta);
    }
    /**
     * Get Oferta value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \Sura\Services\Autoclick\StructType\Oferta[]|null
     */
    public function getOferta()
    {
        return isset($this->Oferta) ? $this->Oferta : null;
    }
    /**
     * This method is responsible for validating the values passed to the setOferta method
     * This method is willingly generated in order to preserve the one-line inline validation within the setOferta method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateOfertaForArrayConstraintsFromSetOferta(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $arrayOfOfertaOfertaItem) {
            // validation for constraint: itemType
            if (!$arrayOfOfertaOfertaItem instanceof \Sura\Services\Autoclick\StructType\Oferta) {
                $invalidValues[] = is_object($arrayOfOfertaOfertaItem) ? get_class($arrayOfOfertaOfertaItem) : sprintf('%s(%s)', gettype($arrayOfOfertaOfertaItem), var_export($arrayOfOfertaOfertaItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The Oferta property can only contain items of type \Sura\Services\Autoclick\StructType\Oferta, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set Oferta value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param \Sura\Services\Autoclick\StructType\Oferta[] $oferta
     * @return \Sura\Services\Autoclick\ArrayType\ArrayOfOferta
     */
    public function setOferta(array $oferta = array())
    {
        // validation for constraint: array
        if ('' !== ($ofertaArrayErrorMessage = self::validateOfertaForArrayConstraintsFromSetOferta($oferta))) {
            throw new \InvalidArgumentException($ofertaArrayErrorMessage, __LINE__);
        }
        if (is_null($oferta) || (is_array($oferta) && empty($oferta))) {
            unset($this->Oferta);
        } else {
            $this->Oferta = $oferta;
        }
        return $this;
    }
    /**
     * Add item to Oferta value
     * @throws \InvalidArgumentException
     * @param \Sura\Services\Autoclick\StructType\Oferta $item
     * @return \Sura\Services\Autoclick\ArrayType\ArrayOfOferta
     */
    public function addToOferta(\Sura\Services\Autoclick\StructType\Oferta $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \Sura\Services\Autoclick\StructType\Oferta) {
            throw new \InvalidArgumentException(sprintf('The Oferta property can only contain items of type \Sura\Services\Autoclick\StructType\Oferta, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->Oferta[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \Sura\Services\Autoclick\StructType\Oferta|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \Sura\Services\Autoclick\StructType\Oferta|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \Sura\Services\Autoclick\StructType\Oferta|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \Sura\Services\Autoclick\StructType\Oferta|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \Sura\Services\Autoclick\StructType\Oferta|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string Oferta
     */
    public function getAttributeName()
    {
        return 'Oferta';
    }
}
