<?php

namespace Sura\Services\Autoclick\ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfOpcional ArrayType
 * Meta information extracted from the WSDL
 * - nillable: true
 * - type: tns:ArrayOfOpcional
 * @subpackage Arrays
 */
class ArrayOfOpcional extends AbstractStructArrayBase
{
    /**
     * The Opcional
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var \Sura\Services\Autoclick\StructType\Opcional[]
     */
    public $Opcional;
    /**
     * Constructor method for ArrayOfOpcional
     * @uses ArrayOfOpcional::setOpcional()
     * @param \Sura\Services\Autoclick\StructType\Opcional[] $opcional
     */
    public function __construct(array $opcional = array())
    {
        $this
            ->setOpcional($opcional);
    }
    /**
     * Get Opcional value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \Sura\Services\Autoclick\StructType\Opcional[]|null
     */
    public function getOpcional()
    {
        return isset($this->Opcional) ? $this->Opcional : null;
    }
    /**
     * This method is responsible for validating the values passed to the setOpcional method
     * This method is willingly generated in order to preserve the one-line inline validation within the setOpcional method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateOpcionalForArrayConstraintsFromSetOpcional(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $arrayOfOpcionalOpcionalItem) {
            // validation for constraint: itemType
            if (!$arrayOfOpcionalOpcionalItem instanceof \Sura\Services\Autoclick\StructType\Opcional) {
                $invalidValues[] = is_object($arrayOfOpcionalOpcionalItem) ? get_class($arrayOfOpcionalOpcionalItem) : sprintf('%s(%s)', gettype($arrayOfOpcionalOpcionalItem), var_export($arrayOfOpcionalOpcionalItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The Opcional property can only contain items of type \Sura\Services\Autoclick\StructType\Opcional, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set Opcional value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param \Sura\Services\Autoclick\StructType\Opcional[] $opcional
     * @return \Sura\Services\Autoclick\ArrayType\ArrayOfOpcional
     */
    public function setOpcional(array $opcional = array())
    {
        // validation for constraint: array
        if ('' !== ($opcionalArrayErrorMessage = self::validateOpcionalForArrayConstraintsFromSetOpcional($opcional))) {
            throw new \InvalidArgumentException($opcionalArrayErrorMessage, __LINE__);
        }
        if (is_null($opcional) || (is_array($opcional) && empty($opcional))) {
            unset($this->Opcional);
        } else {
            $this->Opcional = $opcional;
        }
        return $this;
    }
    /**
     * Add item to Opcional value
     * @throws \InvalidArgumentException
     * @param \Sura\Services\Autoclick\StructType\Opcional $item
     * @return \Sura\Services\Autoclick\ArrayType\ArrayOfOpcional
     */
    public function addToOpcional(\Sura\Services\Autoclick\StructType\Opcional $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \Sura\Services\Autoclick\StructType\Opcional) {
            throw new \InvalidArgumentException(sprintf('The Opcional property can only contain items of type \Sura\Services\Autoclick\StructType\Opcional, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->Opcional[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \Sura\Services\Autoclick\StructType\Opcional|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \Sura\Services\Autoclick\StructType\Opcional|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \Sura\Services\Autoclick\StructType\Opcional|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \Sura\Services\Autoclick\StructType\Opcional|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \Sura\Services\Autoclick\StructType\Opcional|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string Opcional
     */
    public function getAttributeName()
    {
        return 'Opcional';
    }
}
