<?php

namespace Sura\Services\Autoclick\ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfPlanPagoCuotasModel ArrayType
 * Meta information extracted from the WSDL
 * - nillable: true
 * - type: tns:ArrayOfPlanPagoCuotasModel
 * @subpackage Arrays
 */
class ArrayOfPlanPagoCuotasModel extends AbstractStructArrayBase
{
    /**
     * The PlanPagoCuotasModel
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var \Sura\Services\Autoclick\StructType\PlanPagoCuotasModel[]
     */
    public $PlanPagoCuotasModel;
    /**
     * Constructor method for ArrayOfPlanPagoCuotasModel
     * @uses ArrayOfPlanPagoCuotasModel::setPlanPagoCuotasModel()
     * @param \Sura\Services\Autoclick\StructType\PlanPagoCuotasModel[] $planPagoCuotasModel
     */
    public function __construct(array $planPagoCuotasModel = array())
    {
        $this
            ->setPlanPagoCuotasModel($planPagoCuotasModel);
    }
    /**
     * Get PlanPagoCuotasModel value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \Sura\Services\Autoclick\StructType\PlanPagoCuotasModel[]|null
     */
    public function getPlanPagoCuotasModel()
    {
        return isset($this->PlanPagoCuotasModel) ? $this->PlanPagoCuotasModel : null;
    }
    /**
     * This method is responsible for validating the values passed to the setPlanPagoCuotasModel method
     * This method is willingly generated in order to preserve the one-line inline validation within the setPlanPagoCuotasModel method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validatePlanPagoCuotasModelForArrayConstraintsFromSetPlanPagoCuotasModel(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $arrayOfPlanPagoCuotasModelPlanPagoCuotasModelItem) {
            // validation for constraint: itemType
            if (!$arrayOfPlanPagoCuotasModelPlanPagoCuotasModelItem instanceof \Sura\Services\Autoclick\StructType\PlanPagoCuotasModel) {
                $invalidValues[] = is_object($arrayOfPlanPagoCuotasModelPlanPagoCuotasModelItem) ? get_class($arrayOfPlanPagoCuotasModelPlanPagoCuotasModelItem) : sprintf('%s(%s)', gettype($arrayOfPlanPagoCuotasModelPlanPagoCuotasModelItem), var_export($arrayOfPlanPagoCuotasModelPlanPagoCuotasModelItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The PlanPagoCuotasModel property can only contain items of type \Sura\Services\Autoclick\StructType\PlanPagoCuotasModel, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set PlanPagoCuotasModel value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param \Sura\Services\Autoclick\StructType\PlanPagoCuotasModel[] $planPagoCuotasModel
     * @return \Sura\Services\Autoclick\ArrayType\ArrayOfPlanPagoCuotasModel
     */
    public function setPlanPagoCuotasModel(array $planPagoCuotasModel = array())
    {
        // validation for constraint: array
        if ('' !== ($planPagoCuotasModelArrayErrorMessage = self::validatePlanPagoCuotasModelForArrayConstraintsFromSetPlanPagoCuotasModel($planPagoCuotasModel))) {
            throw new \InvalidArgumentException($planPagoCuotasModelArrayErrorMessage, __LINE__);
        }
        if (is_null($planPagoCuotasModel) || (is_array($planPagoCuotasModel) && empty($planPagoCuotasModel))) {
            unset($this->PlanPagoCuotasModel);
        } else {
            $this->PlanPagoCuotasModel = $planPagoCuotasModel;
        }
        return $this;
    }
    /**
     * Add item to PlanPagoCuotasModel value
     * @throws \InvalidArgumentException
     * @param \Sura\Services\Autoclick\StructType\PlanPagoCuotasModel $item
     * @return \Sura\Services\Autoclick\ArrayType\ArrayOfPlanPagoCuotasModel
     */
    public function addToPlanPagoCuotasModel(\Sura\Services\Autoclick\StructType\PlanPagoCuotasModel $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \Sura\Services\Autoclick\StructType\PlanPagoCuotasModel) {
            throw new \InvalidArgumentException(sprintf('The PlanPagoCuotasModel property can only contain items of type \Sura\Services\Autoclick\StructType\PlanPagoCuotasModel, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->PlanPagoCuotasModel[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \Sura\Services\Autoclick\StructType\PlanPagoCuotasModel|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \Sura\Services\Autoclick\StructType\PlanPagoCuotasModel|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \Sura\Services\Autoclick\StructType\PlanPagoCuotasModel|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \Sura\Services\Autoclick\StructType\PlanPagoCuotasModel|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \Sura\Services\Autoclick\StructType\PlanPagoCuotasModel|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string PlanPagoCuotasModel
     */
    public function getAttributeName()
    {
        return 'PlanPagoCuotasModel';
    }
}
