<?php

namespace Sura\Services\Autoclick\StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for ArchivoAdjuntosModel StructType
 * Meta information extracted from the WSDL
 * - nillable: true
 * - type: tns:ArchivoAdjuntosModel
 * @subpackage Structs
 */
class ArchivoAdjuntosModel extends AbstractStructBase
{
    /**
     * The archivosAdjuntoByte
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $archivosAdjuntoByte;
    /**
     * The nombreArchivo
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $nombreArchivo;
    /**
     * Constructor method for ArchivoAdjuntosModel
     * @uses ArchivoAdjuntosModel::setArchivosAdjuntoByte()
     * @uses ArchivoAdjuntosModel::setNombreArchivo()
     * @param string $archivosAdjuntoByte
     * @param string $nombreArchivo
     */
    public function __construct($archivosAdjuntoByte = null, $nombreArchivo = null)
    {
        $this
            ->setArchivosAdjuntoByte($archivosAdjuntoByte)
            ->setNombreArchivo($nombreArchivo);
    }
    /**
     * Get archivosAdjuntoByte value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getArchivosAdjuntoByte()
    {
        return isset($this->archivosAdjuntoByte) ? $this->archivosAdjuntoByte : null;
    }
    /**
     * Set archivosAdjuntoByte value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $archivosAdjuntoByte
     * @return \Sura\Services\Autoclick\StructType\ArchivoAdjuntosModel
     */
    public function setArchivosAdjuntoByte($archivosAdjuntoByte = null)
    {
        // validation for constraint: string
        if (!is_null($archivosAdjuntoByte) && !is_string($archivosAdjuntoByte)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($archivosAdjuntoByte, true), gettype($archivosAdjuntoByte)), __LINE__);
        }
        if (is_null($archivosAdjuntoByte) || (is_array($archivosAdjuntoByte) && empty($archivosAdjuntoByte))) {
            unset($this->archivosAdjuntoByte);
        } else {
            $this->archivosAdjuntoByte = $archivosAdjuntoByte;
        }
        return $this;
    }
    /**
     * Get nombreArchivo value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getNombreArchivo()
    {
        return isset($this->nombreArchivo) ? $this->nombreArchivo : null;
    }
    /**
     * Set nombreArchivo value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $nombreArchivo
     * @return \Sura\Services\Autoclick\StructType\ArchivoAdjuntosModel
     */
    public function setNombreArchivo($nombreArchivo = null)
    {
        // validation for constraint: string
        if (!is_null($nombreArchivo) && !is_string($nombreArchivo)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($nombreArchivo, true), gettype($nombreArchivo)), __LINE__);
        }
        if (is_null($nombreArchivo) || (is_array($nombreArchivo) && empty($nombreArchivo))) {
            unset($this->nombreArchivo);
        } else {
            $this->nombreArchivo = $nombreArchivo;
        }
        return $this;
    }
}
