<?php

namespace Sura\Services\Autoclick\StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for ConsultaPolizaIndividualResponse StructType
 * Meta information extracted from the WSDL
 * - nillable: true
 * - type: tns:ConsultaPolizaIndividualResponse
 * @subpackage Structs
 */
class ConsultaPolizaIndividualResponse extends AbstractStructBase
{
    /**
     * The EstadoTrx
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var int
     */
    public $EstadoTrx;
    /**
     * The FechaInicioVigencia
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var string
     */
    public $FechaInicioVigencia;
    /**
     * The FechaInspeccion
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var string
     */
    public $FechaInspeccion;
    /**
     * The FechaRespuesta
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var string
     */
    public $FechaRespuesta;
    /**
     * The FechaTerminoVigencia
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var string
     */
    public $FechaTerminoVigencia;
    /**
     * The NroInspeccion
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var int
     */
    public $NroInspeccion;
    /**
     * The NroSeguro
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var int
     */
    public $NroSeguro;
    /**
     * The PolizaIndividual
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var int
     */
    public $PolizaIndividual;
    /**
     * The RutAsegurado
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var int
     */
    public $RutAsegurado;
    /**
     * The RutTitular
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var int
     */
    public $RutTitular;
    /**
     * The UrlDocumento
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $UrlDocumento;
    /**
     * The ConsultaPolizaIndividualResult
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var \Sura\Services\Autoclick\StructType\ConsultaPolizaIndividualResponse
     */
    public $ConsultaPolizaIndividualResult;
    /**
     * Constructor method for ConsultaPolizaIndividualResponse
     * @uses ConsultaPolizaIndividualResponse::setEstadoTrx()
     * @uses ConsultaPolizaIndividualResponse::setFechaInicioVigencia()
     * @uses ConsultaPolizaIndividualResponse::setFechaInspeccion()
     * @uses ConsultaPolizaIndividualResponse::setFechaRespuesta()
     * @uses ConsultaPolizaIndividualResponse::setFechaTerminoVigencia()
     * @uses ConsultaPolizaIndividualResponse::setNroInspeccion()
     * @uses ConsultaPolizaIndividualResponse::setNroSeguro()
     * @uses ConsultaPolizaIndividualResponse::setPolizaIndividual()
     * @uses ConsultaPolizaIndividualResponse::setRutAsegurado()
     * @uses ConsultaPolizaIndividualResponse::setRutTitular()
     * @uses ConsultaPolizaIndividualResponse::setUrlDocumento()
     * @uses ConsultaPolizaIndividualResponse::setConsultaPolizaIndividualResult()
     * @param int $estadoTrx
     * @param string $fechaInicioVigencia
     * @param string $fechaInspeccion
     * @param string $fechaRespuesta
     * @param string $fechaTerminoVigencia
     * @param int $nroInspeccion
     * @param int $nroSeguro
     * @param int $polizaIndividual
     * @param int $rutAsegurado
     * @param int $rutTitular
     * @param string $urlDocumento
     * @param \Sura\Services\Autoclick\StructType\ConsultaPolizaIndividualResponse $consultaPolizaIndividualResult
     */
    public function __construct($estadoTrx = null, $fechaInicioVigencia = null, $fechaInspeccion = null, $fechaRespuesta = null, $fechaTerminoVigencia = null, $nroInspeccion = null, $nroSeguro = null, $polizaIndividual = null, $rutAsegurado = null, $rutTitular = null, $urlDocumento = null, \Sura\Services\Autoclick\StructType\ConsultaPolizaIndividualResponse $consultaPolizaIndividualResult = null)
    {
        $this
            ->setEstadoTrx($estadoTrx)
            ->setFechaInicioVigencia($fechaInicioVigencia)
            ->setFechaInspeccion($fechaInspeccion)
            ->setFechaRespuesta($fechaRespuesta)
            ->setFechaTerminoVigencia($fechaTerminoVigencia)
            ->setNroInspeccion($nroInspeccion)
            ->setNroSeguro($nroSeguro)
            ->setPolizaIndividual($polizaIndividual)
            ->setRutAsegurado($rutAsegurado)
            ->setRutTitular($rutTitular)
            ->setUrlDocumento($urlDocumento)
            ->setConsultaPolizaIndividualResult($consultaPolizaIndividualResult);
    }
    /**
     * Get EstadoTrx value
     * @return int|null
     */
    public function getEstadoTrx()
    {
        return $this->EstadoTrx;
    }
    /**
     * Set EstadoTrx value
     * @param int $estadoTrx
     * @return \Sura\Services\Autoclick\StructType\ConsultaPolizaIndividualResponse
     */
    public function setEstadoTrx($estadoTrx = null)
    {
        // validation for constraint: int
        if (!is_null($estadoTrx) && !(is_int($estadoTrx) || ctype_digit($estadoTrx))) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide an integer value, %s given', var_export($estadoTrx, true), gettype($estadoTrx)), __LINE__);
        }
        $this->EstadoTrx = $estadoTrx;
        return $this;
    }
    /**
     * Get FechaInicioVigencia value
     * @return string|null
     */
    public function getFechaInicioVigencia()
    {
        return $this->FechaInicioVigencia;
    }
    /**
     * Set FechaInicioVigencia value
     * @param string $fechaInicioVigencia
     * @return \Sura\Services\Autoclick\StructType\ConsultaPolizaIndividualResponse
     */
    public function setFechaInicioVigencia($fechaInicioVigencia = null)
    {
        // validation for constraint: string
        if (!is_null($fechaInicioVigencia) && !is_string($fechaInicioVigencia)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($fechaInicioVigencia, true), gettype($fechaInicioVigencia)), __LINE__);
        }
        $this->FechaInicioVigencia = $fechaInicioVigencia;
        return $this;
    }
    /**
     * Get FechaInspeccion value
     * @return string|null
     */
    public function getFechaInspeccion()
    {
        return $this->FechaInspeccion;
    }
    /**
     * Set FechaInspeccion value
     * @param string $fechaInspeccion
     * @return \Sura\Services\Autoclick\StructType\ConsultaPolizaIndividualResponse
     */
    public function setFechaInspeccion($fechaInspeccion = null)
    {
        // validation for constraint: string
        if (!is_null($fechaInspeccion) && !is_string($fechaInspeccion)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($fechaInspeccion, true), gettype($fechaInspeccion)), __LINE__);
        }
        $this->FechaInspeccion = $fechaInspeccion;
        return $this;
    }
    /**
     * Get FechaRespuesta value
     * @return string|null
     */
    public function getFechaRespuesta()
    {
        return $this->FechaRespuesta;
    }
    /**
     * Set FechaRespuesta value
     * @param string $fechaRespuesta
     * @return \Sura\Services\Autoclick\StructType\ConsultaPolizaIndividualResponse
     */
    public function setFechaRespuesta($fechaRespuesta = null)
    {
        // validation for constraint: string
        if (!is_null($fechaRespuesta) && !is_string($fechaRespuesta)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($fechaRespuesta, true), gettype($fechaRespuesta)), __LINE__);
        }
        $this->FechaRespuesta = $fechaRespuesta;
        return $this;
    }
    /**
     * Get FechaTerminoVigencia value
     * @return string|null
     */
    public function getFechaTerminoVigencia()
    {
        return $this->FechaTerminoVigencia;
    }
    /**
     * Set FechaTerminoVigencia value
     * @param string $fechaTerminoVigencia
     * @return \Sura\Services\Autoclick\StructType\ConsultaPolizaIndividualResponse
     */
    public function setFechaTerminoVigencia($fechaTerminoVigencia = null)
    {
        // validation for constraint: string
        if (!is_null($fechaTerminoVigencia) && !is_string($fechaTerminoVigencia)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($fechaTerminoVigencia, true), gettype($fechaTerminoVigencia)), __LINE__);
        }
        $this->FechaTerminoVigencia = $fechaTerminoVigencia;
        return $this;
    }
    /**
     * Get NroInspeccion value
     * @return int|null
     */
    public function getNroInspeccion()
    {
        return $this->NroInspeccion;
    }
    /**
     * Set NroInspeccion value
     * @param int $nroInspeccion
     * @return \Sura\Services\Autoclick\StructType\ConsultaPolizaIndividualResponse
     */
    public function setNroInspeccion($nroInspeccion = null)
    {
        // validation for constraint: int
        if (!is_null($nroInspeccion) && !(is_int($nroInspeccion) || ctype_digit($nroInspeccion))) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide an integer value, %s given', var_export($nroInspeccion, true), gettype($nroInspeccion)), __LINE__);
        }
        $this->NroInspeccion = $nroInspeccion;
        return $this;
    }
    /**
     * Get NroSeguro value
     * @return int|null
     */
    public function getNroSeguro()
    {
        return $this->NroSeguro;
    }
    /**
     * Set NroSeguro value
     * @param int $nroSeguro
     * @return \Sura\Services\Autoclick\StructType\ConsultaPolizaIndividualResponse
     */
    public function setNroSeguro($nroSeguro = null)
    {
        // validation for constraint: int
        if (!is_null($nroSeguro) && !(is_int($nroSeguro) || ctype_digit($nroSeguro))) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide an integer value, %s given', var_export($nroSeguro, true), gettype($nroSeguro)), __LINE__);
        }
        $this->NroSeguro = $nroSeguro;
        return $this;
    }
    /**
     * Get PolizaIndividual value
     * @return int|null
     */
    public function getPolizaIndividual()
    {
        return $this->PolizaIndividual;
    }
    /**
     * Set PolizaIndividual value
     * @param int $polizaIndividual
     * @return \Sura\Services\Autoclick\StructType\ConsultaPolizaIndividualResponse
     */
    public function setPolizaIndividual($polizaIndividual = null)
    {
        // validation for constraint: int
        if (!is_null($polizaIndividual) && !(is_int($polizaIndividual) || ctype_digit($polizaIndividual))) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide an integer value, %s given', var_export($polizaIndividual, true), gettype($polizaIndividual)), __LINE__);
        }
        $this->PolizaIndividual = $polizaIndividual;
        return $this;
    }
    /**
     * Get RutAsegurado value
     * @return int|null
     */
    public function getRutAsegurado()
    {
        return $this->RutAsegurado;
    }
    /**
     * Set RutAsegurado value
     * @param int $rutAsegurado
     * @return \Sura\Services\Autoclick\StructType\ConsultaPolizaIndividualResponse
     */
    public function setRutAsegurado($rutAsegurado = null)
    {
        // validation for constraint: int
        if (!is_null($rutAsegurado) && !(is_int($rutAsegurado) || ctype_digit($rutAsegurado))) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide an integer value, %s given', var_export($rutAsegurado, true), gettype($rutAsegurado)), __LINE__);
        }
        $this->RutAsegurado = $rutAsegurado;
        return $this;
    }
    /**
     * Get RutTitular value
     * @return int|null
     */
    public function getRutTitular()
    {
        return $this->RutTitular;
    }
    /**
     * Set RutTitular value
     * @param int $rutTitular
     * @return \Sura\Services\Autoclick\StructType\ConsultaPolizaIndividualResponse
     */
    public function setRutTitular($rutTitular = null)
    {
        // validation for constraint: int
        if (!is_null($rutTitular) && !(is_int($rutTitular) || ctype_digit($rutTitular))) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide an integer value, %s given', var_export($rutTitular, true), gettype($rutTitular)), __LINE__);
        }
        $this->RutTitular = $rutTitular;
        return $this;
    }
    /**
     * Get UrlDocumento value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getUrlDocumento()
    {
        return isset($this->UrlDocumento) ? $this->UrlDocumento : null;
    }
    /**
     * Set UrlDocumento value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $urlDocumento
     * @return \Sura\Services\Autoclick\StructType\ConsultaPolizaIndividualResponse
     */
    public function setUrlDocumento($urlDocumento = null)
    {
        // validation for constraint: string
        if (!is_null($urlDocumento) && !is_string($urlDocumento)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($urlDocumento, true), gettype($urlDocumento)), __LINE__);
        }
        if (is_null($urlDocumento) || (is_array($urlDocumento) && empty($urlDocumento))) {
            unset($this->UrlDocumento);
        } else {
            $this->UrlDocumento = $urlDocumento;
        }
        return $this;
    }
    /**
     * Get ConsultaPolizaIndividualResult value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \Sura\Services\Autoclick\StructType\ConsultaPolizaIndividualResponse|null
     */
    public function getConsultaPolizaIndividualResult()
    {
        return isset($this->ConsultaPolizaIndividualResult) ? $this->ConsultaPolizaIndividualResult : null;
    }
    /**
     * Set ConsultaPolizaIndividualResult value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param \Sura\Services\Autoclick\StructType\ConsultaPolizaIndividualResponse $consultaPolizaIndividualResult
     * @return \Sura\Services\Autoclick\StructType\ConsultaPolizaIndividualResponse
     */
    public function setConsultaPolizaIndividualResult(\Sura\Services\Autoclick\StructType\ConsultaPolizaIndividualResponse $consultaPolizaIndividualResult = null)
    {
        if (is_null($consultaPolizaIndividualResult) || (is_array($consultaPolizaIndividualResult) && empty($consultaPolizaIndividualResult))) {
            unset($this->ConsultaPolizaIndividualResult);
        } else {
            $this->ConsultaPolizaIndividualResult = $consultaPolizaIndividualResult;
        }
        return $this;
    }
}
