<?php

namespace Sura\Services\Autoclick\StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for ContactoPagoModel StructType
 * Meta information extracted from the WSDL
 * - nillable: true
 * - type: tns:ContactoPagoModel
 * @subpackage Structs
 */
class ContactoPagoModel extends AbstractStructBase
{
    /**
     * The ApellidoMaterno
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $ApellidoMaterno;
    /**
     * The ApellidoPaterno
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $ApellidoPaterno;
    /**
     * The DireccionAsegurado
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $DireccionAsegurado;
    /**
     * The EmailAsegurado
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $EmailAsegurado;
    /**
     * The EmailSolicitante
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $EmailSolicitante;
    /**
     * The FonoACliente
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $FonoACliente;
    /**
     * The FonoBCliente
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $FonoBCliente;
    /**
     * The NombreAsegurado
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $NombreAsegurado;
    /**
     * The NombreContacto
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $NombreContacto;
    /**
     * The NombrePagador
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $NombrePagador;
    /**
     * The NombreSolicitante
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $NombreSolicitante;
    /**
     * The RutAsegurado
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $RutAsegurado;
    /**
     * The RutPagador
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $RutPagador;
    /**
     * Constructor method for ContactoPagoModel
     * @uses ContactoPagoModel::setApellidoMaterno()
     * @uses ContactoPagoModel::setApellidoPaterno()
     * @uses ContactoPagoModel::setDireccionAsegurado()
     * @uses ContactoPagoModel::setEmailAsegurado()
     * @uses ContactoPagoModel::setEmailSolicitante()
     * @uses ContactoPagoModel::setFonoACliente()
     * @uses ContactoPagoModel::setFonoBCliente()
     * @uses ContactoPagoModel::setNombreAsegurado()
     * @uses ContactoPagoModel::setNombreContacto()
     * @uses ContactoPagoModel::setNombrePagador()
     * @uses ContactoPagoModel::setNombreSolicitante()
     * @uses ContactoPagoModel::setRutAsegurado()
     * @uses ContactoPagoModel::setRutPagador()
     * @param string $apellidoMaterno
     * @param string $apellidoPaterno
     * @param string $direccionAsegurado
     * @param string $emailAsegurado
     * @param string $emailSolicitante
     * @param string $fonoACliente
     * @param string $fonoBCliente
     * @param string $nombreAsegurado
     * @param string $nombreContacto
     * @param string $nombrePagador
     * @param string $nombreSolicitante
     * @param string $rutAsegurado
     * @param string $rutPagador
     */
    public function __construct($apellidoMaterno = null, $apellidoPaterno = null, $direccionAsegurado = null, $emailAsegurado = null, $emailSolicitante = null, $fonoACliente = null, $fonoBCliente = null, $nombreAsegurado = null, $nombreContacto = null, $nombrePagador = null, $nombreSolicitante = null, $rutAsegurado = null, $rutPagador = null)
    {
        $this
            ->setApellidoMaterno($apellidoMaterno)
            ->setApellidoPaterno($apellidoPaterno)
            ->setDireccionAsegurado($direccionAsegurado)
            ->setEmailAsegurado($emailAsegurado)
            ->setEmailSolicitante($emailSolicitante)
            ->setFonoACliente($fonoACliente)
            ->setFonoBCliente($fonoBCliente)
            ->setNombreAsegurado($nombreAsegurado)
            ->setNombreContacto($nombreContacto)
            ->setNombrePagador($nombrePagador)
            ->setNombreSolicitante($nombreSolicitante)
            ->setRutAsegurado($rutAsegurado)
            ->setRutPagador($rutPagador);
    }
    /**
     * Get ApellidoMaterno value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getApellidoMaterno()
    {
        return isset($this->ApellidoMaterno) ? $this->ApellidoMaterno : null;
    }
    /**
     * Set ApellidoMaterno value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $apellidoMaterno
     * @return \Sura\Services\Autoclick\StructType\ContactoPagoModel
     */
    public function setApellidoMaterno($apellidoMaterno = null)
    {
        // validation for constraint: string
        if (!is_null($apellidoMaterno) && !is_string($apellidoMaterno)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($apellidoMaterno, true), gettype($apellidoMaterno)), __LINE__);
        }
        if (is_null($apellidoMaterno) || (is_array($apellidoMaterno) && empty($apellidoMaterno))) {
            unset($this->ApellidoMaterno);
        } else {
            $this->ApellidoMaterno = $apellidoMaterno;
        }
        return $this;
    }
    /**
     * Get ApellidoPaterno value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getApellidoPaterno()
    {
        return isset($this->ApellidoPaterno) ? $this->ApellidoPaterno : null;
    }
    /**
     * Set ApellidoPaterno value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $apellidoPaterno
     * @return \Sura\Services\Autoclick\StructType\ContactoPagoModel
     */
    public function setApellidoPaterno($apellidoPaterno = null)
    {
        // validation for constraint: string
        if (!is_null($apellidoPaterno) && !is_string($apellidoPaterno)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($apellidoPaterno, true), gettype($apellidoPaterno)), __LINE__);
        }
        if (is_null($apellidoPaterno) || (is_array($apellidoPaterno) && empty($apellidoPaterno))) {
            unset($this->ApellidoPaterno);
        } else {
            $this->ApellidoPaterno = $apellidoPaterno;
        }
        return $this;
    }
    /**
     * Get DireccionAsegurado value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getDireccionAsegurado()
    {
        return isset($this->DireccionAsegurado) ? $this->DireccionAsegurado : null;
    }
    /**
     * Set DireccionAsegurado value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $direccionAsegurado
     * @return \Sura\Services\Autoclick\StructType\ContactoPagoModel
     */
    public function setDireccionAsegurado($direccionAsegurado = null)
    {
        // validation for constraint: string
        if (!is_null($direccionAsegurado) && !is_string($direccionAsegurado)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($direccionAsegurado, true), gettype($direccionAsegurado)), __LINE__);
        }
        if (is_null($direccionAsegurado) || (is_array($direccionAsegurado) && empty($direccionAsegurado))) {
            unset($this->DireccionAsegurado);
        } else {
            $this->DireccionAsegurado = $direccionAsegurado;
        }
        return $this;
    }
    /**
     * Get EmailAsegurado value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getEmailAsegurado()
    {
        return isset($this->EmailAsegurado) ? $this->EmailAsegurado : null;
    }
    /**
     * Set EmailAsegurado value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $emailAsegurado
     * @return \Sura\Services\Autoclick\StructType\ContactoPagoModel
     */
    public function setEmailAsegurado($emailAsegurado = null)
    {
        // validation for constraint: string
        if (!is_null($emailAsegurado) && !is_string($emailAsegurado)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($emailAsegurado, true), gettype($emailAsegurado)), __LINE__);
        }
        if (is_null($emailAsegurado) || (is_array($emailAsegurado) && empty($emailAsegurado))) {
            unset($this->EmailAsegurado);
        } else {
            $this->EmailAsegurado = $emailAsegurado;
        }
        return $this;
    }
    /**
     * Get EmailSolicitante value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getEmailSolicitante()
    {
        return isset($this->EmailSolicitante) ? $this->EmailSolicitante : null;
    }
    /**
     * Set EmailSolicitante value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $emailSolicitante
     * @return \Sura\Services\Autoclick\StructType\ContactoPagoModel
     */
    public function setEmailSolicitante($emailSolicitante = null)
    {
        // validation for constraint: string
        if (!is_null($emailSolicitante) && !is_string($emailSolicitante)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($emailSolicitante, true), gettype($emailSolicitante)), __LINE__);
        }
        if (is_null($emailSolicitante) || (is_array($emailSolicitante) && empty($emailSolicitante))) {
            unset($this->EmailSolicitante);
        } else {
            $this->EmailSolicitante = $emailSolicitante;
        }
        return $this;
    }
    /**
     * Get FonoACliente value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getFonoACliente()
    {
        return isset($this->FonoACliente) ? $this->FonoACliente : null;
    }
    /**
     * Set FonoACliente value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $fonoACliente
     * @return \Sura\Services\Autoclick\StructType\ContactoPagoModel
     */
    public function setFonoACliente($fonoACliente = null)
    {
        // validation for constraint: string
        if (!is_null($fonoACliente) && !is_string($fonoACliente)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($fonoACliente, true), gettype($fonoACliente)), __LINE__);
        }
        if (is_null($fonoACliente) || (is_array($fonoACliente) && empty($fonoACliente))) {
            unset($this->FonoACliente);
        } else {
            $this->FonoACliente = $fonoACliente;
        }
        return $this;
    }
    /**
     * Get FonoBCliente value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getFonoBCliente()
    {
        return isset($this->FonoBCliente) ? $this->FonoBCliente : null;
    }
    /**
     * Set FonoBCliente value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $fonoBCliente
     * @return \Sura\Services\Autoclick\StructType\ContactoPagoModel
     */
    public function setFonoBCliente($fonoBCliente = null)
    {
        // validation for constraint: string
        if (!is_null($fonoBCliente) && !is_string($fonoBCliente)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($fonoBCliente, true), gettype($fonoBCliente)), __LINE__);
        }
        if (is_null($fonoBCliente) || (is_array($fonoBCliente) && empty($fonoBCliente))) {
            unset($this->FonoBCliente);
        } else {
            $this->FonoBCliente = $fonoBCliente;
        }
        return $this;
    }
    /**
     * Get NombreAsegurado value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getNombreAsegurado()
    {
        return isset($this->NombreAsegurado) ? $this->NombreAsegurado : null;
    }
    /**
     * Set NombreAsegurado value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $nombreAsegurado
     * @return \Sura\Services\Autoclick\StructType\ContactoPagoModel
     */
    public function setNombreAsegurado($nombreAsegurado = null)
    {
        // validation for constraint: string
        if (!is_null($nombreAsegurado) && !is_string($nombreAsegurado)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($nombreAsegurado, true), gettype($nombreAsegurado)), __LINE__);
        }
        if (is_null($nombreAsegurado) || (is_array($nombreAsegurado) && empty($nombreAsegurado))) {
            unset($this->NombreAsegurado);
        } else {
            $this->NombreAsegurado = $nombreAsegurado;
        }
        return $this;
    }
    /**
     * Get NombreContacto value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getNombreContacto()
    {
        return isset($this->NombreContacto) ? $this->NombreContacto : null;
    }
    /**
     * Set NombreContacto value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $nombreContacto
     * @return \Sura\Services\Autoclick\StructType\ContactoPagoModel
     */
    public function setNombreContacto($nombreContacto = null)
    {
        // validation for constraint: string
        if (!is_null($nombreContacto) && !is_string($nombreContacto)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($nombreContacto, true), gettype($nombreContacto)), __LINE__);
        }
        if (is_null($nombreContacto) || (is_array($nombreContacto) && empty($nombreContacto))) {
            unset($this->NombreContacto);
        } else {
            $this->NombreContacto = $nombreContacto;
        }
        return $this;
    }
    /**
     * Get NombrePagador value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getNombrePagador()
    {
        return isset($this->NombrePagador) ? $this->NombrePagador : null;
    }
    /**
     * Set NombrePagador value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $nombrePagador
     * @return \Sura\Services\Autoclick\StructType\ContactoPagoModel
     */
    public function setNombrePagador($nombrePagador = null)
    {
        // validation for constraint: string
        if (!is_null($nombrePagador) && !is_string($nombrePagador)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($nombrePagador, true), gettype($nombrePagador)), __LINE__);
        }
        if (is_null($nombrePagador) || (is_array($nombrePagador) && empty($nombrePagador))) {
            unset($this->NombrePagador);
        } else {
            $this->NombrePagador = $nombrePagador;
        }
        return $this;
    }
    /**
     * Get NombreSolicitante value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getNombreSolicitante()
    {
        return isset($this->NombreSolicitante) ? $this->NombreSolicitante : null;
    }
    /**
     * Set NombreSolicitante value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $nombreSolicitante
     * @return \Sura\Services\Autoclick\StructType\ContactoPagoModel
     */
    public function setNombreSolicitante($nombreSolicitante = null)
    {
        // validation for constraint: string
        if (!is_null($nombreSolicitante) && !is_string($nombreSolicitante)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($nombreSolicitante, true), gettype($nombreSolicitante)), __LINE__);
        }
        if (is_null($nombreSolicitante) || (is_array($nombreSolicitante) && empty($nombreSolicitante))) {
            unset($this->NombreSolicitante);
        } else {
            $this->NombreSolicitante = $nombreSolicitante;
        }
        return $this;
    }
    /**
     * Get RutAsegurado value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getRutAsegurado()
    {
        return isset($this->RutAsegurado) ? $this->RutAsegurado : null;
    }
    /**
     * Set RutAsegurado value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $rutAsegurado
     * @return \Sura\Services\Autoclick\StructType\ContactoPagoModel
     */
    public function setRutAsegurado($rutAsegurado = null)
    {
        // validation for constraint: string
        if (!is_null($rutAsegurado) && !is_string($rutAsegurado)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($rutAsegurado, true), gettype($rutAsegurado)), __LINE__);
        }
        if (is_null($rutAsegurado) || (is_array($rutAsegurado) && empty($rutAsegurado))) {
            unset($this->RutAsegurado);
        } else {
            $this->RutAsegurado = $rutAsegurado;
        }
        return $this;
    }
    /**
     * Get RutPagador value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getRutPagador()
    {
        return isset($this->RutPagador) ? $this->RutPagador : null;
    }
    /**
     * Set RutPagador value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $rutPagador
     * @return \Sura\Services\Autoclick\StructType\ContactoPagoModel
     */
    public function setRutPagador($rutPagador = null)
    {
        // validation for constraint: string
        if (!is_null($rutPagador) && !is_string($rutPagador)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($rutPagador, true), gettype($rutPagador)), __LINE__);
        }
        if (is_null($rutPagador) || (is_array($rutPagador) && empty($rutPagador))) {
            unset($this->RutPagador);
        } else {
            $this->RutPagador = $rutPagador;
        }
        return $this;
    }
}
