<?php

namespace Sura\Services\Autoclick\StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for CotizadorVehiculoResult StructType
 * Meta information extracted from the WSDL
 * - nillable: true
 * - type: tns:CotizadorVehiculoResult
 * @subpackage Structs
 */
class CotizadorVehiculoResult extends AbstractStructBase
{
    /**
     * The Planes
     * Meta information extracted from the WSDL
     * - nillable: true
     * @var \Sura\Services\Autoclick\ArrayType\ArrayOfprmCotizacionVehiculoPlanesRespuesta
     */
    public $Planes;
    /**
     * The codigoError
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var int
     */
    public $codigoError;
    /**
     * The estadoTrx
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var int
     */
    public $estadoTrx;
    /**
     * The fecRespuesta
     * @var string
     */
    public $fecRespuesta;
    /**
     * The fecVigenciaCotiz
     * @var string
     */
    public $fecVigenciaCotiz;
    /**
     * The glosaError
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $glosaError;
    /**
     * The idCotizacion
     * Meta information extracted from the WSDL
     * - nillable: true
     * @var string
     */
    public $idCotizacion;
    /**
     * The tiempoRespuesta
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var float
     */
    public $tiempoRespuesta;
    /**
     * Constructor method for CotizadorVehiculoResult
     * @uses CotizadorVehiculoResult::setPlanes()
     * @uses CotizadorVehiculoResult::setCodigoError()
     * @uses CotizadorVehiculoResult::setEstadoTrx()
     * @uses CotizadorVehiculoResult::setFecRespuesta()
     * @uses CotizadorVehiculoResult::setFecVigenciaCotiz()
     * @uses CotizadorVehiculoResult::setGlosaError()
     * @uses CotizadorVehiculoResult::setIdCotizacion()
     * @uses CotizadorVehiculoResult::setTiempoRespuesta()
     * @param \Sura\Services\Autoclick\ArrayType\ArrayOfprmCotizacionVehiculoPlanesRespuesta $planes
     * @param int $codigoError
     * @param int $estadoTrx
     * @param string $fecRespuesta
     * @param string $fecVigenciaCotiz
     * @param string $glosaError
     * @param string $idCotizacion
     * @param float $tiempoRespuesta
     */
    public function __construct(\Sura\Services\Autoclick\ArrayType\ArrayOfprmCotizacionVehiculoPlanesRespuesta $planes = null, $codigoError = null, $estadoTrx = null, $fecRespuesta = null, $fecVigenciaCotiz = null, $glosaError = null, $idCotizacion = null, $tiempoRespuesta = null)
    {
        $this
            ->setPlanes($planes)
            ->setCodigoError($codigoError)
            ->setEstadoTrx($estadoTrx)
            ->setFecRespuesta($fecRespuesta)
            ->setFecVigenciaCotiz($fecVigenciaCotiz)
            ->setGlosaError($glosaError)
            ->setIdCotizacion($idCotizacion)
            ->setTiempoRespuesta($tiempoRespuesta);
    }
    /**
     * Get Planes value
     * @return \Sura\Services\Autoclick\ArrayType\ArrayOfprmCotizacionVehiculoPlanesRespuesta|null
     */
    public function getPlanes()
    {
        return $this->Planes;
    }
    /**
     * Set Planes value
     * @param \Sura\Services\Autoclick\ArrayType\ArrayOfprmCotizacionVehiculoPlanesRespuesta $planes
     * @return \Sura\Services\Autoclick\StructType\CotizadorVehiculoResult
     */
    public function setPlanes(\Sura\Services\Autoclick\ArrayType\ArrayOfprmCotizacionVehiculoPlanesRespuesta $planes = null)
    {
        $this->Planes = $planes;
        return $this;
    }
    /**
     * Get codigoError value
     * @return int|null
     */
    public function getCodigoError()
    {
        return $this->codigoError;
    }
    /**
     * Set codigoError value
     * @param int $codigoError
     * @return \Sura\Services\Autoclick\StructType\CotizadorVehiculoResult
     */
    public function setCodigoError($codigoError = null)
    {
        // validation for constraint: int
        if (!is_null($codigoError) && !(is_int($codigoError) || ctype_digit($codigoError))) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide an integer value, %s given', var_export($codigoError, true), gettype($codigoError)), __LINE__);
        }
        $this->codigoError = $codigoError;
        return $this;
    }
    /**
     * Get estadoTrx value
     * @return int|null
     */
    public function getEstadoTrx()
    {
        return $this->estadoTrx;
    }
    /**
     * Set estadoTrx value
     * @param int $estadoTrx
     * @return \Sura\Services\Autoclick\StructType\CotizadorVehiculoResult
     */
    public function setEstadoTrx($estadoTrx = null)
    {
        // validation for constraint: int
        if (!is_null($estadoTrx) && !(is_int($estadoTrx) || ctype_digit($estadoTrx))) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide an integer value, %s given', var_export($estadoTrx, true), gettype($estadoTrx)), __LINE__);
        }
        $this->estadoTrx = $estadoTrx;
        return $this;
    }
    /**
     * Get fecRespuesta value
     * @return string|null
     */
    public function getFecRespuesta()
    {
        return $this->fecRespuesta;
    }
    /**
     * Set fecRespuesta value
     * @param string $fecRespuesta
     * @return \Sura\Services\Autoclick\StructType\CotizadorVehiculoResult
     */
    public function setFecRespuesta($fecRespuesta = null)
    {
        // validation for constraint: string
        if (!is_null($fecRespuesta) && !is_string($fecRespuesta)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($fecRespuesta, true), gettype($fecRespuesta)), __LINE__);
        }
        $this->fecRespuesta = $fecRespuesta;
        return $this;
    }
    /**
     * Get fecVigenciaCotiz value
     * @return string|null
     */
    public function getFecVigenciaCotiz()
    {
        return $this->fecVigenciaCotiz;
    }
    /**
     * Set fecVigenciaCotiz value
     * @param string $fecVigenciaCotiz
     * @return \Sura\Services\Autoclick\StructType\CotizadorVehiculoResult
     */
    public function setFecVigenciaCotiz($fecVigenciaCotiz = null)
    {
        // validation for constraint: string
        if (!is_null($fecVigenciaCotiz) && !is_string($fecVigenciaCotiz)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($fecVigenciaCotiz, true), gettype($fecVigenciaCotiz)), __LINE__);
        }
        $this->fecVigenciaCotiz = $fecVigenciaCotiz;
        return $this;
    }
    /**
     * Get glosaError value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getGlosaError()
    {
        return isset($this->glosaError) ? $this->glosaError : null;
    }
    /**
     * Set glosaError value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $glosaError
     * @return \Sura\Services\Autoclick\StructType\CotizadorVehiculoResult
     */
    public function setGlosaError($glosaError = null)
    {
        // validation for constraint: string
        if (!is_null($glosaError) && !is_string($glosaError)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($glosaError, true), gettype($glosaError)), __LINE__);
        }
        if (is_null($glosaError) || (is_array($glosaError) && empty($glosaError))) {
            unset($this->glosaError);
        } else {
            $this->glosaError = $glosaError;
        }
        return $this;
    }
    /**
     * Get idCotizacion value
     * @return string|null
     */
    public function getIdCotizacion()
    {
        return $this->idCotizacion;
    }
    /**
     * Set idCotizacion value
     * @param string $idCotizacion
     * @return \Sura\Services\Autoclick\StructType\CotizadorVehiculoResult
     */
    public function setIdCotizacion($idCotizacion = null)
    {
        // validation for constraint: string
        if (!is_null($idCotizacion) && !is_string($idCotizacion)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($idCotizacion, true), gettype($idCotizacion)), __LINE__);
        }
        $this->idCotizacion = $idCotizacion;
        return $this;
    }
    /**
     * Get tiempoRespuesta value
     * @return float|null
     */
    public function getTiempoRespuesta()
    {
        return $this->tiempoRespuesta;
    }
    /**
     * Set tiempoRespuesta value
     * @param float $tiempoRespuesta
     * @return \Sura\Services\Autoclick\StructType\CotizadorVehiculoResult
     */
    public function setTiempoRespuesta($tiempoRespuesta = null)
    {
        // validation for constraint: float
        if (!is_null($tiempoRespuesta) && !(is_float($tiempoRespuesta) || is_numeric($tiempoRespuesta))) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a float value, %s given', var_export($tiempoRespuesta, true), gettype($tiempoRespuesta)), __LINE__);
        }
        $this->tiempoRespuesta = $tiempoRespuesta;
        return $this;
    }
}
