<?php

namespace Sura\Services\Autoclick\StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for DatosTransaccionExterna StructType
 * Meta information extracted from the WSDL
 * - nillable: true
 * - type: tns:DatosTransaccionExterna
 * @subpackage Structs
 */
class DatosTransaccionExterna extends AbstractStructBase
{
    /**
     * The contrasena
     * Meta information extracted from the WSDL
     * - nillable: true
     * @var string
     */
    public $contrasena;
    /**
     * The fechaHora
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var string
     */
    public $fechaHora;
    /**
     * The idContexto
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $idContexto;
    /**
     * The idTransaccion
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $idTransaccion;
    /**
     * The sistema
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $sistema;
    /**
     * The usuario
     * Meta information extracted from the WSDL
     * - nillable: true
     * @var string
     */
    public $usuario;
    /**
     * Constructor method for DatosTransaccionExterna
     * @uses DatosTransaccionExterna::setContrasena()
     * @uses DatosTransaccionExterna::setFechaHora()
     * @uses DatosTransaccionExterna::setIdContexto()
     * @uses DatosTransaccionExterna::setIdTransaccion()
     * @uses DatosTransaccionExterna::setSistema()
     * @uses DatosTransaccionExterna::setUsuario()
     * @param string $contrasena
     * @param string $fechaHora
     * @param string $idContexto
     * @param string $idTransaccion
     * @param string $sistema
     * @param string $usuario
     */
    public function __construct($contrasena = null, $fechaHora = null, $idContexto = null, $idTransaccion = null, $sistema = null, $usuario = null)
    {
        $this
            ->setContrasena($contrasena)
            ->setFechaHora($fechaHora)
            ->setIdContexto($idContexto)
            ->setIdTransaccion($idTransaccion)
            ->setSistema($sistema)
            ->setUsuario($usuario);
    }
    /**
     * Get contrasena value
     * @return string|null
     */
    public function getContrasena()
    {
        return $this->contrasena;
    }
    /**
     * Set contrasena value
     * @param string $contrasena
     * @return \Sura\Services\Autoclick\StructType\DatosTransaccionExterna
     */
    public function setContrasena($contrasena = null)
    {
        // validation for constraint: string
        if (!is_null($contrasena) && !is_string($contrasena)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($contrasena, true), gettype($contrasena)), __LINE__);
        }
        $this->contrasena = $contrasena;
        return $this;
    }
    /**
     * Get fechaHora value
     * @return string|null
     */
    public function getFechaHora()
    {
        return $this->fechaHora;
    }
    /**
     * Set fechaHora value
     * @param string $fechaHora
     * @return \Sura\Services\Autoclick\StructType\DatosTransaccionExterna
     */
    public function setFechaHora($fechaHora = null)
    {
        // validation for constraint: string
        if (!is_null($fechaHora) && !is_string($fechaHora)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($fechaHora, true), gettype($fechaHora)), __LINE__);
        }
        $this->fechaHora = $fechaHora;
        return $this;
    }
    /**
     * Get idContexto value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getIdContexto()
    {
        return isset($this->idContexto) ? $this->idContexto : null;
    }
    /**
     * Set idContexto value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $idContexto
     * @return \Sura\Services\Autoclick\StructType\DatosTransaccionExterna
     */
    public function setIdContexto($idContexto = null)
    {
        // validation for constraint: string
        if (!is_null($idContexto) && !is_string($idContexto)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($idContexto, true), gettype($idContexto)), __LINE__);
        }
        if (is_null($idContexto) || (is_array($idContexto) && empty($idContexto))) {
            unset($this->idContexto);
        } else {
            $this->idContexto = $idContexto;
        }
        return $this;
    }
    /**
     * Get idTransaccion value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getIdTransaccion()
    {
        return isset($this->idTransaccion) ? $this->idTransaccion : null;
    }
    /**
     * Set idTransaccion value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $idTransaccion
     * @return \Sura\Services\Autoclick\StructType\DatosTransaccionExterna
     */
    public function setIdTransaccion($idTransaccion = null)
    {
        // validation for constraint: string
        if (!is_null($idTransaccion) && !is_string($idTransaccion)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($idTransaccion, true), gettype($idTransaccion)), __LINE__);
        }
        if (is_null($idTransaccion) || (is_array($idTransaccion) && empty($idTransaccion))) {
            unset($this->idTransaccion);
        } else {
            $this->idTransaccion = $idTransaccion;
        }
        return $this;
    }
    /**
     * Get sistema value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getSistema()
    {
        return isset($this->sistema) ? $this->sistema : null;
    }
    /**
     * Set sistema value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $sistema
     * @return \Sura\Services\Autoclick\StructType\DatosTransaccionExterna
     */
    public function setSistema($sistema = null)
    {
        // validation for constraint: string
        if (!is_null($sistema) && !is_string($sistema)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($sistema, true), gettype($sistema)), __LINE__);
        }
        if (is_null($sistema) || (is_array($sistema) && empty($sistema))) {
            unset($this->sistema);
        } else {
            $this->sistema = $sistema;
        }
        return $this;
    }
    /**
     * Get usuario value
     * @return string|null
     */
    public function getUsuario()
    {
        return $this->usuario;
    }
    /**
     * Set usuario value
     * @param string $usuario
     * @return \Sura\Services\Autoclick\StructType\DatosTransaccionExterna
     */
    public function setUsuario($usuario = null)
    {
        // validation for constraint: string
        if (!is_null($usuario) && !is_string($usuario)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($usuario, true), gettype($usuario)), __LINE__);
        }
        $this->usuario = $usuario;
        return $this;
    }
}
