<?php

namespace Sura\Services\Autoclick\StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for DatosTransaccionExternaBaseResponse StructType
 * Meta information extracted from the WSDL
 * - nillable: true
 * - type: tns:DatosTransaccionExternaBaseResponse
 * @subpackage Structs
 */
class DatosTransaccionExternaBaseResponse extends AbstractStructBase
{
    /**
     * The cotizacionServicioID
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $cotizacionServicioID;
    /**
     * The fechaHora
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var string
     */
    public $fechaHora;
    /**
     * The fechaHoraFin
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var string
     */
    public $fechaHoraFin;
    /**
     * The idContexto
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $idContexto;
    /**
     * The idTransaccion
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $idTransaccion;
    /**
     * The sistema
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $sistema;
    /**
     * Constructor method for DatosTransaccionExternaBaseResponse
     * @uses DatosTransaccionExternaBaseResponse::setCotizacionServicioID()
     * @uses DatosTransaccionExternaBaseResponse::setFechaHora()
     * @uses DatosTransaccionExternaBaseResponse::setFechaHoraFin()
     * @uses DatosTransaccionExternaBaseResponse::setIdContexto()
     * @uses DatosTransaccionExternaBaseResponse::setIdTransaccion()
     * @uses DatosTransaccionExternaBaseResponse::setSistema()
     * @param string $cotizacionServicioID
     * @param string $fechaHora
     * @param string $fechaHoraFin
     * @param string $idContexto
     * @param string $idTransaccion
     * @param string $sistema
     */
    public function __construct($cotizacionServicioID = null, $fechaHora = null, $fechaHoraFin = null, $idContexto = null, $idTransaccion = null, $sistema = null)
    {
        $this
            ->setCotizacionServicioID($cotizacionServicioID)
            ->setFechaHora($fechaHora)
            ->setFechaHoraFin($fechaHoraFin)
            ->setIdContexto($idContexto)
            ->setIdTransaccion($idTransaccion)
            ->setSistema($sistema);
    }
    /**
     * Get cotizacionServicioID value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getCotizacionServicioID()
    {
        return isset($this->cotizacionServicioID) ? $this->cotizacionServicioID : null;
    }
    /**
     * Set cotizacionServicioID value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $cotizacionServicioID
     * @return \Sura\Services\Autoclick\StructType\DatosTransaccionExternaBaseResponse
     */
    public function setCotizacionServicioID($cotizacionServicioID = null)
    {
        // validation for constraint: string
        if (!is_null($cotizacionServicioID) && !is_string($cotizacionServicioID)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($cotizacionServicioID, true), gettype($cotizacionServicioID)), __LINE__);
        }
        if (is_null($cotizacionServicioID) || (is_array($cotizacionServicioID) && empty($cotizacionServicioID))) {
            unset($this->cotizacionServicioID);
        } else {
            $this->cotizacionServicioID = $cotizacionServicioID;
        }
        return $this;
    }
    /**
     * Get fechaHora value
     * @return string|null
     */
    public function getFechaHora()
    {
        return $this->fechaHora;
    }
    /**
     * Set fechaHora value
     * @param string $fechaHora
     * @return \Sura\Services\Autoclick\StructType\DatosTransaccionExternaBaseResponse
     */
    public function setFechaHora($fechaHora = null)
    {
        // validation for constraint: string
        if (!is_null($fechaHora) && !is_string($fechaHora)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($fechaHora, true), gettype($fechaHora)), __LINE__);
        }
        $this->fechaHora = $fechaHora;
        return $this;
    }
    /**
     * Get fechaHoraFin value
     * @return string|null
     */
    public function getFechaHoraFin()
    {
        return $this->fechaHoraFin;
    }
    /**
     * Set fechaHoraFin value
     * @param string $fechaHoraFin
     * @return \Sura\Services\Autoclick\StructType\DatosTransaccionExternaBaseResponse
     */
    public function setFechaHoraFin($fechaHoraFin = null)
    {
        // validation for constraint: string
        if (!is_null($fechaHoraFin) && !is_string($fechaHoraFin)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($fechaHoraFin, true), gettype($fechaHoraFin)), __LINE__);
        }
        $this->fechaHoraFin = $fechaHoraFin;
        return $this;
    }
    /**
     * Get idContexto value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getIdContexto()
    {
        return isset($this->idContexto) ? $this->idContexto : null;
    }
    /**
     * Set idContexto value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $idContexto
     * @return \Sura\Services\Autoclick\StructType\DatosTransaccionExternaBaseResponse
     */
    public function setIdContexto($idContexto = null)
    {
        // validation for constraint: string
        if (!is_null($idContexto) && !is_string($idContexto)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($idContexto, true), gettype($idContexto)), __LINE__);
        }
        if (is_null($idContexto) || (is_array($idContexto) && empty($idContexto))) {
            unset($this->idContexto);
        } else {
            $this->idContexto = $idContexto;
        }
        return $this;
    }
    /**
     * Get idTransaccion value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getIdTransaccion()
    {
        return isset($this->idTransaccion) ? $this->idTransaccion : null;
    }
    /**
     * Set idTransaccion value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $idTransaccion
     * @return \Sura\Services\Autoclick\StructType\DatosTransaccionExternaBaseResponse
     */
    public function setIdTransaccion($idTransaccion = null)
    {
        // validation for constraint: string
        if (!is_null($idTransaccion) && !is_string($idTransaccion)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($idTransaccion, true), gettype($idTransaccion)), __LINE__);
        }
        if (is_null($idTransaccion) || (is_array($idTransaccion) && empty($idTransaccion))) {
            unset($this->idTransaccion);
        } else {
            $this->idTransaccion = $idTransaccion;
        }
        return $this;
    }
    /**
     * Get sistema value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getSistema()
    {
        return isset($this->sistema) ? $this->sistema : null;
    }
    /**
     * Set sistema value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $sistema
     * @return \Sura\Services\Autoclick\StructType\DatosTransaccionExternaBaseResponse
     */
    public function setSistema($sistema = null)
    {
        // validation for constraint: string
        if (!is_null($sistema) && !is_string($sistema)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($sistema, true), gettype($sistema)), __LINE__);
        }
        if (is_null($sistema) || (is_array($sistema) && empty($sistema))) {
            unset($this->sistema);
        } else {
            $this->sistema = $sistema;
        }
        return $this;
    }
}
