<?php

namespace Sura\Services\Autoclick\StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for DeducibleDescuentoModel StructType
 * Meta information extracted from the WSDL
 * - nillable: true
 * - type: tns:DeducibleDescuentoModel
 * @subpackage Structs
 */
class DeducibleDescuentoModel extends AbstractStructBase
{
    /**
     * The CodigoDeducible
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $CodigoDeducible;
    /**
     * The ComisionPorcentaje
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $ComisionPorcentaje;
    /**
     * The ComisionUF
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var float
     */
    public $ComisionUF;
    /**
     * The Deducible
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $Deducible;
    /**
     * The Iva
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var float
     */
    public $Iva;
    /**
     * The NombrePlan
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $NombrePlan;
    /**
     * The PrimaAfecta
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var float
     */
    public $PrimaAfecta;
    /**
     * The PrimaBruta
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var float
     */
    public $PrimaBruta;
    /**
     * The PrimaExenta
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var float
     */
    public $PrimaExenta;
    /**
     * The ValorEnPeso
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $ValorEnPeso;
    /**
     * The ValorEnUf
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $ValorEnUf;
    /**
     * The ValorUf
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $ValorUf;
    /**
     * Constructor method for DeducibleDescuentoModel
     * @uses DeducibleDescuentoModel::setCodigoDeducible()
     * @uses DeducibleDescuentoModel::setComisionPorcentaje()
     * @uses DeducibleDescuentoModel::setComisionUF()
     * @uses DeducibleDescuentoModel::setDeducible()
     * @uses DeducibleDescuentoModel::setIva()
     * @uses DeducibleDescuentoModel::setNombrePlan()
     * @uses DeducibleDescuentoModel::setPrimaAfecta()
     * @uses DeducibleDescuentoModel::setPrimaBruta()
     * @uses DeducibleDescuentoModel::setPrimaExenta()
     * @uses DeducibleDescuentoModel::setValorEnPeso()
     * @uses DeducibleDescuentoModel::setValorEnUf()
     * @uses DeducibleDescuentoModel::setValorUf()
     * @param string $codigoDeducible
     * @param string $comisionPorcentaje
     * @param float $comisionUF
     * @param string $deducible
     * @param float $iva
     * @param string $nombrePlan
     * @param float $primaAfecta
     * @param float $primaBruta
     * @param float $primaExenta
     * @param string $valorEnPeso
     * @param string $valorEnUf
     * @param string $valorUf
     */
    public function __construct($codigoDeducible = null, $comisionPorcentaje = null, $comisionUF = null, $deducible = null, $iva = null, $nombrePlan = null, $primaAfecta = null, $primaBruta = null, $primaExenta = null, $valorEnPeso = null, $valorEnUf = null, $valorUf = null)
    {
        $this
            ->setCodigoDeducible($codigoDeducible)
            ->setComisionPorcentaje($comisionPorcentaje)
            ->setComisionUF($comisionUF)
            ->setDeducible($deducible)
            ->setIva($iva)
            ->setNombrePlan($nombrePlan)
            ->setPrimaAfecta($primaAfecta)
            ->setPrimaBruta($primaBruta)
            ->setPrimaExenta($primaExenta)
            ->setValorEnPeso($valorEnPeso)
            ->setValorEnUf($valorEnUf)
            ->setValorUf($valorUf);
    }
    /**
     * Get CodigoDeducible value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getCodigoDeducible()
    {
        return isset($this->CodigoDeducible) ? $this->CodigoDeducible : null;
    }
    /**
     * Set CodigoDeducible value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $codigoDeducible
     * @return \Sura\Services\Autoclick\StructType\DeducibleDescuentoModel
     */
    public function setCodigoDeducible($codigoDeducible = null)
    {
        // validation for constraint: string
        if (!is_null($codigoDeducible) && !is_string($codigoDeducible)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($codigoDeducible, true), gettype($codigoDeducible)), __LINE__);
        }
        if (is_null($codigoDeducible) || (is_array($codigoDeducible) && empty($codigoDeducible))) {
            unset($this->CodigoDeducible);
        } else {
            $this->CodigoDeducible = $codigoDeducible;
        }
        return $this;
    }
    /**
     * Get ComisionPorcentaje value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getComisionPorcentaje()
    {
        return isset($this->ComisionPorcentaje) ? $this->ComisionPorcentaje : null;
    }
    /**
     * Set ComisionPorcentaje value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $comisionPorcentaje
     * @return \Sura\Services\Autoclick\StructType\DeducibleDescuentoModel
     */
    public function setComisionPorcentaje($comisionPorcentaje = null)
    {
        // validation for constraint: string
        if (!is_null($comisionPorcentaje) && !is_string($comisionPorcentaje)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($comisionPorcentaje, true), gettype($comisionPorcentaje)), __LINE__);
        }
        if (is_null($comisionPorcentaje) || (is_array($comisionPorcentaje) && empty($comisionPorcentaje))) {
            unset($this->ComisionPorcentaje);
        } else {
            $this->ComisionPorcentaje = $comisionPorcentaje;
        }
        return $this;
    }
    /**
     * Get ComisionUF value
     * @return float|null
     */
    public function getComisionUF()
    {
        return $this->ComisionUF;
    }
    /**
     * Set ComisionUF value
     * @param float $comisionUF
     * @return \Sura\Services\Autoclick\StructType\DeducibleDescuentoModel
     */
    public function setComisionUF($comisionUF = null)
    {
        // validation for constraint: float
        if (!is_null($comisionUF) && !(is_float($comisionUF) || is_numeric($comisionUF))) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a float value, %s given', var_export($comisionUF, true), gettype($comisionUF)), __LINE__);
        }
        $this->ComisionUF = $comisionUF;
        return $this;
    }
    /**
     * Get Deducible value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getDeducible()
    {
        return isset($this->Deducible) ? $this->Deducible : null;
    }
    /**
     * Set Deducible value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $deducible
     * @return \Sura\Services\Autoclick\StructType\DeducibleDescuentoModel
     */
    public function setDeducible($deducible = null)
    {
        // validation for constraint: string
        if (!is_null($deducible) && !is_string($deducible)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($deducible, true), gettype($deducible)), __LINE__);
        }
        if (is_null($deducible) || (is_array($deducible) && empty($deducible))) {
            unset($this->Deducible);
        } else {
            $this->Deducible = $deducible;
        }
        return $this;
    }
    /**
     * Get Iva value
     * @return float|null
     */
    public function getIva()
    {
        return $this->Iva;
    }
    /**
     * Set Iva value
     * @param float $iva
     * @return \Sura\Services\Autoclick\StructType\DeducibleDescuentoModel
     */
    public function setIva($iva = null)
    {
        // validation for constraint: float
        if (!is_null($iva) && !(is_float($iva) || is_numeric($iva))) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a float value, %s given', var_export($iva, true), gettype($iva)), __LINE__);
        }
        $this->Iva = $iva;
        return $this;
    }
    /**
     * Get NombrePlan value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getNombrePlan()
    {
        return isset($this->NombrePlan) ? $this->NombrePlan : null;
    }
    /**
     * Set NombrePlan value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $nombrePlan
     * @return \Sura\Services\Autoclick\StructType\DeducibleDescuentoModel
     */
    public function setNombrePlan($nombrePlan = null)
    {
        // validation for constraint: string
        if (!is_null($nombrePlan) && !is_string($nombrePlan)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($nombrePlan, true), gettype($nombrePlan)), __LINE__);
        }
        if (is_null($nombrePlan) || (is_array($nombrePlan) && empty($nombrePlan))) {
            unset($this->NombrePlan);
        } else {
            $this->NombrePlan = $nombrePlan;
        }
        return $this;
    }
    /**
     * Get PrimaAfecta value
     * @return float|null
     */
    public function getPrimaAfecta()
    {
        return $this->PrimaAfecta;
    }
    /**
     * Set PrimaAfecta value
     * @param float $primaAfecta
     * @return \Sura\Services\Autoclick\StructType\DeducibleDescuentoModel
     */
    public function setPrimaAfecta($primaAfecta = null)
    {
        // validation for constraint: float
        if (!is_null($primaAfecta) && !(is_float($primaAfecta) || is_numeric($primaAfecta))) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a float value, %s given', var_export($primaAfecta, true), gettype($primaAfecta)), __LINE__);
        }
        $this->PrimaAfecta = $primaAfecta;
        return $this;
    }
    /**
     * Get PrimaBruta value
     * @return float|null
     */
    public function getPrimaBruta()
    {
        return $this->PrimaBruta;
    }
    /**
     * Set PrimaBruta value
     * @param float $primaBruta
     * @return \Sura\Services\Autoclick\StructType\DeducibleDescuentoModel
     */
    public function setPrimaBruta($primaBruta = null)
    {
        // validation for constraint: float
        if (!is_null($primaBruta) && !(is_float($primaBruta) || is_numeric($primaBruta))) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a float value, %s given', var_export($primaBruta, true), gettype($primaBruta)), __LINE__);
        }
        $this->PrimaBruta = $primaBruta;
        return $this;
    }
    /**
     * Get PrimaExenta value
     * @return float|null
     */
    public function getPrimaExenta()
    {
        return $this->PrimaExenta;
    }
    /**
     * Set PrimaExenta value
     * @param float $primaExenta
     * @return \Sura\Services\Autoclick\StructType\DeducibleDescuentoModel
     */
    public function setPrimaExenta($primaExenta = null)
    {
        // validation for constraint: float
        if (!is_null($primaExenta) && !(is_float($primaExenta) || is_numeric($primaExenta))) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a float value, %s given', var_export($primaExenta, true), gettype($primaExenta)), __LINE__);
        }
        $this->PrimaExenta = $primaExenta;
        return $this;
    }
    /**
     * Get ValorEnPeso value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getValorEnPeso()
    {
        return isset($this->ValorEnPeso) ? $this->ValorEnPeso : null;
    }
    /**
     * Set ValorEnPeso value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $valorEnPeso
     * @return \Sura\Services\Autoclick\StructType\DeducibleDescuentoModel
     */
    public function setValorEnPeso($valorEnPeso = null)
    {
        // validation for constraint: string
        if (!is_null($valorEnPeso) && !is_string($valorEnPeso)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($valorEnPeso, true), gettype($valorEnPeso)), __LINE__);
        }
        if (is_null($valorEnPeso) || (is_array($valorEnPeso) && empty($valorEnPeso))) {
            unset($this->ValorEnPeso);
        } else {
            $this->ValorEnPeso = $valorEnPeso;
        }
        return $this;
    }
    /**
     * Get ValorEnUf value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getValorEnUf()
    {
        return isset($this->ValorEnUf) ? $this->ValorEnUf : null;
    }
    /**
     * Set ValorEnUf value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $valorEnUf
     * @return \Sura\Services\Autoclick\StructType\DeducibleDescuentoModel
     */
    public function setValorEnUf($valorEnUf = null)
    {
        // validation for constraint: string
        if (!is_null($valorEnUf) && !is_string($valorEnUf)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($valorEnUf, true), gettype($valorEnUf)), __LINE__);
        }
        if (is_null($valorEnUf) || (is_array($valorEnUf) && empty($valorEnUf))) {
            unset($this->ValorEnUf);
        } else {
            $this->ValorEnUf = $valorEnUf;
        }
        return $this;
    }
    /**
     * Get ValorUf value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getValorUf()
    {
        return isset($this->ValorUf) ? $this->ValorUf : null;
    }
    /**
     * Set ValorUf value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $valorUf
     * @return \Sura\Services\Autoclick\StructType\DeducibleDescuentoModel
     */
    public function setValorUf($valorUf = null)
    {
        // validation for constraint: string
        if (!is_null($valorUf) && !is_string($valorUf)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($valorUf, true), gettype($valorUf)), __LINE__);
        }
        if (is_null($valorUf) || (is_array($valorUf) && empty($valorUf))) {
            unset($this->ValorUf);
        } else {
            $this->ValorUf = $valorUf;
        }
        return $this;
    }
}
