<?php

namespace Sura\Services\Autoclick\StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for DetalleProductoBaseModel StructType
 * Meta information extracted from the WSDL
 * - nillable: true
 * - type: tns:DetalleProductoBaseModel
 * @subpackage Structs
 */
class DetalleProductoBaseModel extends AbstractStructBase
{
    /**
     * The CodigoProducto
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $CodigoProducto;
    /**
     * The Producto
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $Producto;
    /**
     * Constructor method for DetalleProductoBaseModel
     * @uses DetalleProductoBaseModel::setCodigoProducto()
     * @uses DetalleProductoBaseModel::setProducto()
     * @param string $codigoProducto
     * @param string $producto
     */
    public function __construct($codigoProducto = null, $producto = null)
    {
        $this
            ->setCodigoProducto($codigoProducto)
            ->setProducto($producto);
    }
    /**
     * Get CodigoProducto value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getCodigoProducto()
    {
        return isset($this->CodigoProducto) ? $this->CodigoProducto : null;
    }
    /**
     * Set CodigoProducto value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $codigoProducto
     * @return \Sura\Services\Autoclick\StructType\DetalleProductoBaseModel
     */
    public function setCodigoProducto($codigoProducto = null)
    {
        // validation for constraint: string
        if (!is_null($codigoProducto) && !is_string($codigoProducto)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($codigoProducto, true), gettype($codigoProducto)), __LINE__);
        }
        if (is_null($codigoProducto) || (is_array($codigoProducto) && empty($codigoProducto))) {
            unset($this->CodigoProducto);
        } else {
            $this->CodigoProducto = $codigoProducto;
        }
        return $this;
    }
    /**
     * Get Producto value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getProducto()
    {
        return isset($this->Producto) ? $this->Producto : null;
    }
    /**
     * Set Producto value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $producto
     * @return \Sura\Services\Autoclick\StructType\DetalleProductoBaseModel
     */
    public function setProducto($producto = null)
    {
        // validation for constraint: string
        if (!is_null($producto) && !is_string($producto)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($producto, true), gettype($producto)), __LINE__);
        }
        if (is_null($producto) || (is_array($producto) && empty($producto))) {
            unset($this->Producto);
        } else {
            $this->Producto = $producto;
        }
        return $this;
    }
}
