<?php

namespace Sura\Services\Autoclick\StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for EstadoCotizacion StructType
 * Meta information extracted from the WSDL
 * - nillable: true
 * - type: tns:EstadoCotizacion
 * @subpackage Structs
 */
class EstadoCotizacion extends AbstractStructBase
{
    /**
     * The descripcion
     * Meta information extracted from the WSDL
     * - nillable: true
     * @var string
     */
    public $descripcion;
    /**
     * The esVigente
     * @var bool
     */
    public $esVigente;
    /**
     * Constructor method for EstadoCotizacion
     * @uses EstadoCotizacion::setDescripcion()
     * @uses EstadoCotizacion::setEsVigente()
     * @param string $descripcion
     * @param bool $esVigente
     */
    public function __construct($descripcion = null, $esVigente = null)
    {
        $this
            ->setDescripcion($descripcion)
            ->setEsVigente($esVigente);
    }
    /**
     * Get descripcion value
     * @return string|null
     */
    public function getDescripcion()
    {
        return $this->descripcion;
    }
    /**
     * Set descripcion value
     * @param string $descripcion
     * @return \Sura\Services\Autoclick\StructType\EstadoCotizacion
     */
    public function setDescripcion($descripcion = null)
    {
        // validation for constraint: string
        if (!is_null($descripcion) && !is_string($descripcion)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($descripcion, true), gettype($descripcion)), __LINE__);
        }
        $this->descripcion = $descripcion;
        return $this;
    }
    /**
     * Get esVigente value
     * @return bool|null
     */
    public function getEsVigente()
    {
        return $this->esVigente;
    }
    /**
     * Set esVigente value
     * @param bool $esVigente
     * @return \Sura\Services\Autoclick\StructType\EstadoCotizacion
     */
    public function setEsVigente($esVigente = null)
    {
        // validation for constraint: boolean
        if (!is_null($esVigente) && !is_bool($esVigente)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a bool, %s given', var_export($esVigente, true), gettype($esVigente)), __LINE__);
        }
        $this->esVigente = $esVigente;
        return $this;
    }
}
