<?php

namespace Sura\Services\Autoclick\StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for Fault StructType
 * Meta information extracted from the WSDL
 * - nillable: true
 * - type: tns:Fault
 * @subpackage Structs
 */
class Fault extends AbstractStructBase
{
    /**
     * The codigoError
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $codigoError;
    /**
     * The detalleError
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $detalleError;
    /**
     * Constructor method for Fault
     * @uses Fault::setCodigoError()
     * @uses Fault::setDetalleError()
     * @param string $codigoError
     * @param string $detalleError
     */
    public function __construct($codigoError = null, $detalleError = null)
    {
        $this
            ->setCodigoError($codigoError)
            ->setDetalleError($detalleError);
    }
    /**
     * Get codigoError value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getCodigoError()
    {
        return isset($this->codigoError) ? $this->codigoError : null;
    }
    /**
     * Set codigoError value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $codigoError
     * @return \Sura\Services\Autoclick\StructType\Fault
     */
    public function setCodigoError($codigoError = null)
    {
        // validation for constraint: string
        if (!is_null($codigoError) && !is_string($codigoError)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($codigoError, true), gettype($codigoError)), __LINE__);
        }
        if (is_null($codigoError) || (is_array($codigoError) && empty($codigoError))) {
            unset($this->codigoError);
        } else {
            $this->codigoError = $codigoError;
        }
        return $this;
    }
    /**
     * Get detalleError value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getDetalleError()
    {
        return isset($this->detalleError) ? $this->detalleError : null;
    }
    /**
     * Set detalleError value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $detalleError
     * @return \Sura\Services\Autoclick\StructType\Fault
     */
    public function setDetalleError($detalleError = null)
    {
        // validation for constraint: string
        if (!is_null($detalleError) && !is_string($detalleError)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($detalleError, true), gettype($detalleError)), __LINE__);
        }
        if (is_null($detalleError) || (is_array($detalleError) && empty($detalleError))) {
            unset($this->detalleError);
        } else {
            $this->detalleError = $detalleError;
        }
        return $this;
    }
}
