<?php

namespace Sura\Services\Autoclick\StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for GeneraCotizacionResponse StructType
 * @subpackage Structs
 */
class GeneraCotizacionResponse extends AbstractStructBase
{
    /**
     * The Fault
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var \Sura\Services\Autoclick\StructType\Fault
     */
    public $Fault;
    /**
     * The NumeroCotizacion
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $NumeroCotizacion;
    /**
     * Constructor method for GeneraCotizacionResponse
     * @uses GeneraCotizacionResponse::setFault()
     * @uses GeneraCotizacionResponse::setNumeroCotizacion()
     * @param \Sura\Services\Autoclick\StructType\Fault $fault
     * @param string $numeroCotizacion
     */
    public function __construct(\Sura\Services\Autoclick\StructType\Fault $fault = null, $numeroCotizacion = null)
    {
        $this
            ->setFault($fault)
            ->setNumeroCotizacion($numeroCotizacion);
    }
    /**
     * Get Fault value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \Sura\Services\Autoclick\StructType\Fault|null
     */
    public function getFault()
    {
        return isset($this->Fault) ? $this->Fault : null;
    }
    /**
     * Set Fault value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param \Sura\Services\Autoclick\StructType\Fault $fault
     * @return \Sura\Services\Autoclick\StructType\GeneraCotizacionResponse
     */
    public function setFault(\Sura\Services\Autoclick\StructType\Fault $fault = null)
    {
        if (is_null($fault) || (is_array($fault) && empty($fault))) {
            unset($this->Fault);
        } else {
            $this->Fault = $fault;
        }
        return $this;
    }
    /**
     * Get NumeroCotizacion value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getNumeroCotizacion()
    {
        return isset($this->NumeroCotizacion) ? $this->NumeroCotizacion : null;
    }
    /**
     * Set NumeroCotizacion value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $numeroCotizacion
     * @return \Sura\Services\Autoclick\StructType\GeneraCotizacionResponse
     */
    public function setNumeroCotizacion($numeroCotizacion = null)
    {
        // validation for constraint: string
        if (!is_null($numeroCotizacion) && !is_string($numeroCotizacion)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($numeroCotizacion, true), gettype($numeroCotizacion)), __LINE__);
        }
        if (is_null($numeroCotizacion) || (is_array($numeroCotizacion) && empty($numeroCotizacion))) {
            unset($this->NumeroCotizacion);
        } else {
            $this->NumeroCotizacion = $numeroCotizacion;
        }
        return $this;
    }
}
