<?php

namespace Sura\Services\Autoclick\StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for InformacionPagoModel StructType
 * Meta information extracted from the WSDL
 * - nillable: true
 * - type: tns:InformacionPagoModel
 * @subpackage Structs
 */
class InformacionPagoModel extends AbstractStructBase
{
    /**
     * The EstadoMandato
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $EstadoMandato;
    /**
     * The FechaVencimiento
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var string
     */
    public $FechaVencimiento;
    /**
     * The FormaPago
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $FormaPago;
    /**
     * The IdBanco
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $IdBanco;
    /**
     * The NumeroCuotas
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var int
     */
    public $NumeroCuotas;
    /**
     * The NumeroMandato
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $NumeroMandato;
    /**
     * The ObservacionMandato
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $ObservacionMandato;
    /**
     * Constructor method for InformacionPagoModel
     * @uses InformacionPagoModel::setEstadoMandato()
     * @uses InformacionPagoModel::setFechaVencimiento()
     * @uses InformacionPagoModel::setFormaPago()
     * @uses InformacionPagoModel::setIdBanco()
     * @uses InformacionPagoModel::setNumeroCuotas()
     * @uses InformacionPagoModel::setNumeroMandato()
     * @uses InformacionPagoModel::setObservacionMandato()
     * @param string $estadoMandato
     * @param string $fechaVencimiento
     * @param string $formaPago
     * @param string $idBanco
     * @param int $numeroCuotas
     * @param string $numeroMandato
     * @param string $observacionMandato
     */
    public function __construct($estadoMandato = null, $fechaVencimiento = null, $formaPago = null, $idBanco = null, $numeroCuotas = null, $numeroMandato = null, $observacionMandato = null)
    {
        $this
            ->setEstadoMandato($estadoMandato)
            ->setFechaVencimiento($fechaVencimiento)
            ->setFormaPago($formaPago)
            ->setIdBanco($idBanco)
            ->setNumeroCuotas($numeroCuotas)
            ->setNumeroMandato($numeroMandato)
            ->setObservacionMandato($observacionMandato);
    }
    /**
     * Get EstadoMandato value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getEstadoMandato()
    {
        return isset($this->EstadoMandato) ? $this->EstadoMandato : null;
    }
    /**
     * Set EstadoMandato value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $estadoMandato
     * @return \Sura\Services\Autoclick\StructType\InformacionPagoModel
     */
    public function setEstadoMandato($estadoMandato = null)
    {
        // validation for constraint: string
        if (!is_null($estadoMandato) && !is_string($estadoMandato)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($estadoMandato, true), gettype($estadoMandato)), __LINE__);
        }
        if (is_null($estadoMandato) || (is_array($estadoMandato) && empty($estadoMandato))) {
            unset($this->EstadoMandato);
        } else {
            $this->EstadoMandato = $estadoMandato;
        }
        return $this;
    }
    /**
     * Get FechaVencimiento value
     * @return string|null
     */
    public function getFechaVencimiento()
    {
        return $this->FechaVencimiento;
    }
    /**
     * Set FechaVencimiento value
     * @param string $fechaVencimiento
     * @return \Sura\Services\Autoclick\StructType\InformacionPagoModel
     */
    public function setFechaVencimiento($fechaVencimiento = null)
    {
        // validation for constraint: string
        if (!is_null($fechaVencimiento) && !is_string($fechaVencimiento)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($fechaVencimiento, true), gettype($fechaVencimiento)), __LINE__);
        }
        $this->FechaVencimiento = $fechaVencimiento;
        return $this;
    }
    /**
     * Get FormaPago value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getFormaPago()
    {
        return isset($this->FormaPago) ? $this->FormaPago : null;
    }
    /**
     * Set FormaPago value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $formaPago
     * @return \Sura\Services\Autoclick\StructType\InformacionPagoModel
     */
    public function setFormaPago($formaPago = null)
    {
        // validation for constraint: string
        if (!is_null($formaPago) && !is_string($formaPago)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($formaPago, true), gettype($formaPago)), __LINE__);
        }
        if (is_null($formaPago) || (is_array($formaPago) && empty($formaPago))) {
            unset($this->FormaPago);
        } else {
            $this->FormaPago = $formaPago;
        }
        return $this;
    }
    /**
     * Get IdBanco value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getIdBanco()
    {
        return isset($this->IdBanco) ? $this->IdBanco : null;
    }
    /**
     * Set IdBanco value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $idBanco
     * @return \Sura\Services\Autoclick\StructType\InformacionPagoModel
     */
    public function setIdBanco($idBanco = null)
    {
        // validation for constraint: string
        if (!is_null($idBanco) && !is_string($idBanco)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($idBanco, true), gettype($idBanco)), __LINE__);
        }
        if (is_null($idBanco) || (is_array($idBanco) && empty($idBanco))) {
            unset($this->IdBanco);
        } else {
            $this->IdBanco = $idBanco;
        }
        return $this;
    }
    /**
     * Get NumeroCuotas value
     * @return int|null
     */
    public function getNumeroCuotas()
    {
        return $this->NumeroCuotas;
    }
    /**
     * Set NumeroCuotas value
     * @param int $numeroCuotas
     * @return \Sura\Services\Autoclick\StructType\InformacionPagoModel
     */
    public function setNumeroCuotas($numeroCuotas = null)
    {
        // validation for constraint: int
        if (!is_null($numeroCuotas) && !(is_int($numeroCuotas) || ctype_digit($numeroCuotas))) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide an integer value, %s given', var_export($numeroCuotas, true), gettype($numeroCuotas)), __LINE__);
        }
        $this->NumeroCuotas = $numeroCuotas;
        return $this;
    }
    /**
     * Get NumeroMandato value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getNumeroMandato()
    {
        return isset($this->NumeroMandato) ? $this->NumeroMandato : null;
    }
    /**
     * Set NumeroMandato value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $numeroMandato
     * @return \Sura\Services\Autoclick\StructType\InformacionPagoModel
     */
    public function setNumeroMandato($numeroMandato = null)
    {
        // validation for constraint: string
        if (!is_null($numeroMandato) && !is_string($numeroMandato)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($numeroMandato, true), gettype($numeroMandato)), __LINE__);
        }
        if (is_null($numeroMandato) || (is_array($numeroMandato) && empty($numeroMandato))) {
            unset($this->NumeroMandato);
        } else {
            $this->NumeroMandato = $numeroMandato;
        }
        return $this;
    }
    /**
     * Get ObservacionMandato value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getObservacionMandato()
    {
        return isset($this->ObservacionMandato) ? $this->ObservacionMandato : null;
    }
    /**
     * Set ObservacionMandato value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $observacionMandato
     * @return \Sura\Services\Autoclick\StructType\InformacionPagoModel
     */
    public function setObservacionMandato($observacionMandato = null)
    {
        // validation for constraint: string
        if (!is_null($observacionMandato) && !is_string($observacionMandato)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($observacionMandato, true), gettype($observacionMandato)), __LINE__);
        }
        if (is_null($observacionMandato) || (is_array($observacionMandato) && empty($observacionMandato))) {
            unset($this->ObservacionMandato);
        } else {
            $this->ObservacionMandato = $observacionMandato;
        }
        return $this;
    }
}
