<?php

namespace Sura\Services\Autoclick\StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for PolizaExternaMateriaContinuidadCoberturaModel StructType
 * Meta information extracted from the WSDL
 * - nillable: true
 * - type: tns:PolizaExternaMateriaContinuidadCoberturaModel
 * @subpackage Structs
 */
class PolizaExternaMateriaContinuidadCoberturaModel extends AbstractStructBase
{
    /**
     * The ArchivosAdjuntos
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var \Sura\Services\Autoclick\ArrayType\ArrayOfArchivoAdjuntosModel
     */
    public $ArchivosAdjuntos;
    /**
     * The companiaID
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var int
     */
    public $companiaID;
    /**
     * The deducibleAnterior
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var string
     */
    public $deducibleAnterior;
    /**
     * The fechaVencimiento
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var string
     */
    public $fechaVencimiento;
    /**
     * The numeroPolizaAnterior
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $numeroPolizaAnterior;
    /**
     * Constructor method for PolizaExternaMateriaContinuidadCoberturaModel
     * @uses PolizaExternaMateriaContinuidadCoberturaModel::setArchivosAdjuntos()
     * @uses PolizaExternaMateriaContinuidadCoberturaModel::setCompaniaID()
     * @uses PolizaExternaMateriaContinuidadCoberturaModel::setDeducibleAnterior()
     * @uses PolizaExternaMateriaContinuidadCoberturaModel::setFechaVencimiento()
     * @uses PolizaExternaMateriaContinuidadCoberturaModel::setNumeroPolizaAnterior()
     * @param \Sura\Services\Autoclick\ArrayType\ArrayOfArchivoAdjuntosModel $archivosAdjuntos
     * @param int $companiaID
     * @param string $deducibleAnterior
     * @param string $fechaVencimiento
     * @param string $numeroPolizaAnterior
     */
    public function __construct(\Sura\Services\Autoclick\ArrayType\ArrayOfArchivoAdjuntosModel $archivosAdjuntos = null, $companiaID = null, $deducibleAnterior = null, $fechaVencimiento = null, $numeroPolizaAnterior = null)
    {
        $this
            ->setArchivosAdjuntos($archivosAdjuntos)
            ->setCompaniaID($companiaID)
            ->setDeducibleAnterior($deducibleAnterior)
            ->setFechaVencimiento($fechaVencimiento)
            ->setNumeroPolizaAnterior($numeroPolizaAnterior);
    }
    /**
     * Get ArchivosAdjuntos value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \Sura\Services\Autoclick\ArrayType\ArrayOfArchivoAdjuntosModel|null
     */
    public function getArchivosAdjuntos()
    {
        return isset($this->ArchivosAdjuntos) ? $this->ArchivosAdjuntos : null;
    }
    /**
     * Set ArchivosAdjuntos value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param \Sura\Services\Autoclick\ArrayType\ArrayOfArchivoAdjuntosModel $archivosAdjuntos
     * @return \Sura\Services\Autoclick\StructType\PolizaExternaMateriaContinuidadCoberturaModel
     */
    public function setArchivosAdjuntos(\Sura\Services\Autoclick\ArrayType\ArrayOfArchivoAdjuntosModel $archivosAdjuntos = null)
    {
        if (is_null($archivosAdjuntos) || (is_array($archivosAdjuntos) && empty($archivosAdjuntos))) {
            unset($this->ArchivosAdjuntos);
        } else {
            $this->ArchivosAdjuntos = $archivosAdjuntos;
        }
        return $this;
    }
    /**
     * Get companiaID value
     * @return int|null
     */
    public function getCompaniaID()
    {
        return $this->companiaID;
    }
    /**
     * Set companiaID value
     * @param int $companiaID
     * @return \Sura\Services\Autoclick\StructType\PolizaExternaMateriaContinuidadCoberturaModel
     */
    public function setCompaniaID($companiaID = null)
    {
        // validation for constraint: int
        if (!is_null($companiaID) && !(is_int($companiaID) || ctype_digit($companiaID))) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide an integer value, %s given', var_export($companiaID, true), gettype($companiaID)), __LINE__);
        }
        $this->companiaID = $companiaID;
        return $this;
    }
    /**
     * Get deducibleAnterior value
     * @return string|null
     */
    public function getDeducibleAnterior()
    {
        return $this->deducibleAnterior;
    }
    /**
     * Set deducibleAnterior value
     * @uses \Sura\Services\Autoclick\EnumType\DeducibleAnterior::valueIsValid()
     * @uses \Sura\Services\Autoclick\EnumType\DeducibleAnterior::getValidValues()
     * @throws \InvalidArgumentException
     * @param string $deducibleAnterior
     * @return \Sura\Services\Autoclick\StructType\PolizaExternaMateriaContinuidadCoberturaModel
     */
    public function setDeducibleAnterior($deducibleAnterior = null)
    {
        // validation for constraint: enumeration
        if (!\Sura\Services\Autoclick\EnumType\DeducibleAnterior::valueIsValid($deducibleAnterior)) {
            throw new \InvalidArgumentException(sprintf('Invalid value(s) %s, please use one of: %s from enumeration class \Sura\Services\Autoclick\EnumType\DeducibleAnterior', is_array($deducibleAnterior) ? implode(', ', $deducibleAnterior) : var_export($deducibleAnterior, true), implode(', ', \Sura\Services\Autoclick\EnumType\DeducibleAnterior::getValidValues())), __LINE__);
        }
        $this->deducibleAnterior = $deducibleAnterior;
        return $this;
    }
    /**
     * Get fechaVencimiento value
     * @return string|null
     */
    public function getFechaVencimiento()
    {
        return $this->fechaVencimiento;
    }
    /**
     * Set fechaVencimiento value
     * @param string $fechaVencimiento
     * @return \Sura\Services\Autoclick\StructType\PolizaExternaMateriaContinuidadCoberturaModel
     */
    public function setFechaVencimiento($fechaVencimiento = null)
    {
        // validation for constraint: string
        if (!is_null($fechaVencimiento) && !is_string($fechaVencimiento)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($fechaVencimiento, true), gettype($fechaVencimiento)), __LINE__);
        }
        $this->fechaVencimiento = $fechaVencimiento;
        return $this;
    }
    /**
     * Get numeroPolizaAnterior value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getNumeroPolizaAnterior()
    {
        return isset($this->numeroPolizaAnterior) ? $this->numeroPolizaAnterior : null;
    }
    /**
     * Set numeroPolizaAnterior value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $numeroPolizaAnterior
     * @return \Sura\Services\Autoclick\StructType\PolizaExternaMateriaContinuidadCoberturaModel
     */
    public function setNumeroPolizaAnterior($numeroPolizaAnterior = null)
    {
        // validation for constraint: string
        if (!is_null($numeroPolizaAnterior) && !is_string($numeroPolizaAnterior)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($numeroPolizaAnterior, true), gettype($numeroPolizaAnterior)), __LINE__);
        }
        if (is_null($numeroPolizaAnterior) || (is_array($numeroPolizaAnterior) && empty($numeroPolizaAnterior))) {
            unset($this->numeroPolizaAnterior);
        } else {
            $this->numeroPolizaAnterior = $numeroPolizaAnterior;
        }
        return $this;
    }
}
