<?php

namespace Sura\Services\Autoclick\StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for PolizaExternaMateriaFacturaModel StructType
 * Meta information extracted from the WSDL
 * - nillable: true
 * - type: tns:PolizaExternaMateriaFacturaModel
 * @subpackage Structs
 */
class PolizaExternaMateriaFacturaModel extends AbstractStructBase
{
    /**
     * The ArchivosAdjuntos
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var \Sura\Services\Autoclick\ArrayType\ArrayOfArchivoAdjuntosModel
     */
    public $ArchivosAdjuntos;
    /**
     * The facturaGuiaDespacho
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $facturaGuiaDespacho;
    /**
     * The fechaFacturaGuiaDespacho
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var string
     */
    public $fechaFacturaGuiaDespacho;
    /**
     * Constructor method for PolizaExternaMateriaFacturaModel
     * @uses PolizaExternaMateriaFacturaModel::setArchivosAdjuntos()
     * @uses PolizaExternaMateriaFacturaModel::setFacturaGuiaDespacho()
     * @uses PolizaExternaMateriaFacturaModel::setFechaFacturaGuiaDespacho()
     * @param \Sura\Services\Autoclick\ArrayType\ArrayOfArchivoAdjuntosModel $archivosAdjuntos
     * @param string $facturaGuiaDespacho
     * @param string $fechaFacturaGuiaDespacho
     */
    public function __construct(\Sura\Services\Autoclick\ArrayType\ArrayOfArchivoAdjuntosModel $archivosAdjuntos = null, $facturaGuiaDespacho = null, $fechaFacturaGuiaDespacho = null)
    {
        $this
            ->setArchivosAdjuntos($archivosAdjuntos)
            ->setFacturaGuiaDespacho($facturaGuiaDespacho)
            ->setFechaFacturaGuiaDespacho($fechaFacturaGuiaDespacho);
    }
    /**
     * Get ArchivosAdjuntos value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \Sura\Services\Autoclick\ArrayType\ArrayOfArchivoAdjuntosModel|null
     */
    public function getArchivosAdjuntos()
    {
        return isset($this->ArchivosAdjuntos) ? $this->ArchivosAdjuntos : null;
    }
    /**
     * Set ArchivosAdjuntos value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param \Sura\Services\Autoclick\ArrayType\ArrayOfArchivoAdjuntosModel $archivosAdjuntos
     * @return \Sura\Services\Autoclick\StructType\PolizaExternaMateriaFacturaModel
     */
    public function setArchivosAdjuntos(\Sura\Services\Autoclick\ArrayType\ArrayOfArchivoAdjuntosModel $archivosAdjuntos = null)
    {
        if (is_null($archivosAdjuntos) || (is_array($archivosAdjuntos) && empty($archivosAdjuntos))) {
            unset($this->ArchivosAdjuntos);
        } else {
            $this->ArchivosAdjuntos = $archivosAdjuntos;
        }
        return $this;
    }
    /**
     * Get facturaGuiaDespacho value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getFacturaGuiaDespacho()
    {
        return isset($this->facturaGuiaDespacho) ? $this->facturaGuiaDespacho : null;
    }
    /**
     * Set facturaGuiaDespacho value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $facturaGuiaDespacho
     * @return \Sura\Services\Autoclick\StructType\PolizaExternaMateriaFacturaModel
     */
    public function setFacturaGuiaDespacho($facturaGuiaDespacho = null)
    {
        // validation for constraint: string
        if (!is_null($facturaGuiaDespacho) && !is_string($facturaGuiaDespacho)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($facturaGuiaDespacho, true), gettype($facturaGuiaDespacho)), __LINE__);
        }
        if (is_null($facturaGuiaDespacho) || (is_array($facturaGuiaDespacho) && empty($facturaGuiaDespacho))) {
            unset($this->facturaGuiaDespacho);
        } else {
            $this->facturaGuiaDespacho = $facturaGuiaDespacho;
        }
        return $this;
    }
    /**
     * Get fechaFacturaGuiaDespacho value
     * @return string|null
     */
    public function getFechaFacturaGuiaDespacho()
    {
        return $this->fechaFacturaGuiaDespacho;
    }
    /**
     * Set fechaFacturaGuiaDespacho value
     * @param string $fechaFacturaGuiaDespacho
     * @return \Sura\Services\Autoclick\StructType\PolizaExternaMateriaFacturaModel
     */
    public function setFechaFacturaGuiaDespacho($fechaFacturaGuiaDespacho = null)
    {
        // validation for constraint: string
        if (!is_null($fechaFacturaGuiaDespacho) && !is_string($fechaFacturaGuiaDespacho)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($fechaFacturaGuiaDespacho, true), gettype($fechaFacturaGuiaDespacho)), __LINE__);
        }
        $this->fechaFacturaGuiaDespacho = $fechaFacturaGuiaDespacho;
        return $this;
    }
}
