<?php

namespace Sura\Services\Autoclick\StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for prmCotizacionVehiculoPlanesRespuesta StructType
 * Meta information extracted from the WSDL
 * - nillable: true
 * - type: tns:prmCotizacionVehiculoPlanesRespuesta
 * @subpackage Structs
 */
class PrmCotizacionVehiculoPlanesRespuesta extends AbstractStructBase
{
    /**
     * The codPlan
     * @var int
     */
    public $codPlan;
    /**
     * The codProducto
     * @var int
     */
    public $codProducto;
    /**
     * The nomPlan
     * Meta information extracted from the WSDL
     * - nillable: true
     * @var string
     */
    public $nomPlan;
    /**
     * The numeroCuotas
     * @var int
     */
    public $numeroCuotas;
    /**
     * The primaBrutaUfAnual
     * @var float
     */
    public $primaBrutaUfAnual;
    /**
     * The primaBrutaUfMensual
     * @var float
     */
    public $primaBrutaUfMensual;
    /**
     * The primaNetaUfAnual
     * @var float
     */
    public $primaNetaUfAnual;
    /**
     * Constructor method for prmCotizacionVehiculoPlanesRespuesta
     * @uses PrmCotizacionVehiculoPlanesRespuesta::setCodPlan()
     * @uses PrmCotizacionVehiculoPlanesRespuesta::setCodProducto()
     * @uses PrmCotizacionVehiculoPlanesRespuesta::setNomPlan()
     * @uses PrmCotizacionVehiculoPlanesRespuesta::setNumeroCuotas()
     * @uses PrmCotizacionVehiculoPlanesRespuesta::setPrimaBrutaUfAnual()
     * @uses PrmCotizacionVehiculoPlanesRespuesta::setPrimaBrutaUfMensual()
     * @uses PrmCotizacionVehiculoPlanesRespuesta::setPrimaNetaUfAnual()
     * @param int $codPlan
     * @param int $codProducto
     * @param string $nomPlan
     * @param int $numeroCuotas
     * @param float $primaBrutaUfAnual
     * @param float $primaBrutaUfMensual
     * @param float $primaNetaUfAnual
     */
    public function __construct($codPlan = null, $codProducto = null, $nomPlan = null, $numeroCuotas = null, $primaBrutaUfAnual = null, $primaBrutaUfMensual = null, $primaNetaUfAnual = null)
    {
        $this
            ->setCodPlan($codPlan)
            ->setCodProducto($codProducto)
            ->setNomPlan($nomPlan)
            ->setNumeroCuotas($numeroCuotas)
            ->setPrimaBrutaUfAnual($primaBrutaUfAnual)
            ->setPrimaBrutaUfMensual($primaBrutaUfMensual)
            ->setPrimaNetaUfAnual($primaNetaUfAnual);
    }
    /**
     * Get codPlan value
     * @return int|null
     */
    public function getCodPlan()
    {
        return $this->codPlan;
    }
    /**
     * Set codPlan value
     * @param int $codPlan
     * @return \Sura\Services\Autoclick\StructType\PrmCotizacionVehiculoPlanesRespuesta
     */
    public function setCodPlan($codPlan = null)
    {
        // validation for constraint: int
        if (!is_null($codPlan) && !(is_int($codPlan) || ctype_digit($codPlan))) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide an integer value, %s given', var_export($codPlan, true), gettype($codPlan)), __LINE__);
        }
        $this->codPlan = $codPlan;
        return $this;
    }
    /**
     * Get codProducto value
     * @return int|null
     */
    public function getCodProducto()
    {
        return $this->codProducto;
    }
    /**
     * Set codProducto value
     * @param int $codProducto
     * @return \Sura\Services\Autoclick\StructType\PrmCotizacionVehiculoPlanesRespuesta
     */
    public function setCodProducto($codProducto = null)
    {
        // validation for constraint: int
        if (!is_null($codProducto) && !(is_int($codProducto) || ctype_digit($codProducto))) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide an integer value, %s given', var_export($codProducto, true), gettype($codProducto)), __LINE__);
        }
        $this->codProducto = $codProducto;
        return $this;
    }
    /**
     * Get nomPlan value
     * @return string|null
     */
    public function getNomPlan()
    {
        return $this->nomPlan;
    }
    /**
     * Set nomPlan value
     * @param string $nomPlan
     * @return \Sura\Services\Autoclick\StructType\PrmCotizacionVehiculoPlanesRespuesta
     */
    public function setNomPlan($nomPlan = null)
    {
        // validation for constraint: string
        if (!is_null($nomPlan) && !is_string($nomPlan)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($nomPlan, true), gettype($nomPlan)), __LINE__);
        }
        $this->nomPlan = $nomPlan;
        return $this;
    }
    /**
     * Get numeroCuotas value
     * @return int|null
     */
    public function getNumeroCuotas()
    {
        return $this->numeroCuotas;
    }
    /**
     * Set numeroCuotas value
     * @param int $numeroCuotas
     * @return \Sura\Services\Autoclick\StructType\PrmCotizacionVehiculoPlanesRespuesta
     */
    public function setNumeroCuotas($numeroCuotas = null)
    {
        // validation for constraint: int
        if (!is_null($numeroCuotas) && !(is_int($numeroCuotas) || ctype_digit($numeroCuotas))) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide an integer value, %s given', var_export($numeroCuotas, true), gettype($numeroCuotas)), __LINE__);
        }
        $this->numeroCuotas = $numeroCuotas;
        return $this;
    }
    /**
     * Get primaBrutaUfAnual value
     * @return float|null
     */
    public function getPrimaBrutaUfAnual()
    {
        return $this->primaBrutaUfAnual;
    }
    /**
     * Set primaBrutaUfAnual value
     * @param float $primaBrutaUfAnual
     * @return \Sura\Services\Autoclick\StructType\PrmCotizacionVehiculoPlanesRespuesta
     */
    public function setPrimaBrutaUfAnual($primaBrutaUfAnual = null)
    {
        // validation for constraint: float
        if (!is_null($primaBrutaUfAnual) && !(is_float($primaBrutaUfAnual) || is_numeric($primaBrutaUfAnual))) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a float value, %s given', var_export($primaBrutaUfAnual, true), gettype($primaBrutaUfAnual)), __LINE__);
        }
        $this->primaBrutaUfAnual = $primaBrutaUfAnual;
        return $this;
    }
    /**
     * Get primaBrutaUfMensual value
     * @return float|null
     */
    public function getPrimaBrutaUfMensual()
    {
        return $this->primaBrutaUfMensual;
    }
    /**
     * Set primaBrutaUfMensual value
     * @param float $primaBrutaUfMensual
     * @return \Sura\Services\Autoclick\StructType\PrmCotizacionVehiculoPlanesRespuesta
     */
    public function setPrimaBrutaUfMensual($primaBrutaUfMensual = null)
    {
        // validation for constraint: float
        if (!is_null($primaBrutaUfMensual) && !(is_float($primaBrutaUfMensual) || is_numeric($primaBrutaUfMensual))) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a float value, %s given', var_export($primaBrutaUfMensual, true), gettype($primaBrutaUfMensual)), __LINE__);
        }
        $this->primaBrutaUfMensual = $primaBrutaUfMensual;
        return $this;
    }
    /**
     * Get primaNetaUfAnual value
     * @return float|null
     */
    public function getPrimaNetaUfAnual()
    {
        return $this->primaNetaUfAnual;
    }
    /**
     * Set primaNetaUfAnual value
     * @param float $primaNetaUfAnual
     * @return \Sura\Services\Autoclick\StructType\PrmCotizacionVehiculoPlanesRespuesta
     */
    public function setPrimaNetaUfAnual($primaNetaUfAnual = null)
    {
        // validation for constraint: float
        if (!is_null($primaNetaUfAnual) && !(is_float($primaNetaUfAnual) || is_numeric($primaNetaUfAnual))) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a float value, %s given', var_export($primaNetaUfAnual, true), gettype($primaNetaUfAnual)), __LINE__);
        }
        $this->primaNetaUfAnual = $primaNetaUfAnual;
        return $this;
    }
}
