<?php

namespace Sura\Services\Autoclick\StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for SiniestralidadModel StructType
 * Meta information extracted from the WSDL
 * - nillable: true
 * - type: tns:SiniestralidadModel
 * @subpackage Structs
 */
class SiniestralidadModel extends AbstractStructBase
{
    /**
     * The Bloqueado
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var bool
     */
    public $Bloqueado;
    /**
     * The Factor
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var float
     */
    public $Factor;
    /**
     * The Patente
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $Patente;
    /**
     * Constructor method for SiniestralidadModel
     * @uses SiniestralidadModel::setBloqueado()
     * @uses SiniestralidadModel::setFactor()
     * @uses SiniestralidadModel::setPatente()
     * @param bool $bloqueado
     * @param float $factor
     * @param string $patente
     */
    public function __construct($bloqueado = null, $factor = null, $patente = null)
    {
        $this
            ->setBloqueado($bloqueado)
            ->setFactor($factor)
            ->setPatente($patente);
    }
    /**
     * Get Bloqueado value
     * @return bool|null
     */
    public function getBloqueado()
    {
        return $this->Bloqueado;
    }
    /**
     * Set Bloqueado value
     * @param bool $bloqueado
     * @return \Sura\Services\Autoclick\StructType\SiniestralidadModel
     */
    public function setBloqueado($bloqueado = null)
    {
        // validation for constraint: boolean
        if (!is_null($bloqueado) && !is_bool($bloqueado)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a bool, %s given', var_export($bloqueado, true), gettype($bloqueado)), __LINE__);
        }
        $this->Bloqueado = $bloqueado;
        return $this;
    }
    /**
     * Get Factor value
     * @return float|null
     */
    public function getFactor()
    {
        return $this->Factor;
    }
    /**
     * Set Factor value
     * @param float $factor
     * @return \Sura\Services\Autoclick\StructType\SiniestralidadModel
     */
    public function setFactor($factor = null)
    {
        // validation for constraint: float
        if (!is_null($factor) && !(is_float($factor) || is_numeric($factor))) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a float value, %s given', var_export($factor, true), gettype($factor)), __LINE__);
        }
        $this->Factor = $factor;
        return $this;
    }
    /**
     * Get Patente value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getPatente()
    {
        return isset($this->Patente) ? $this->Patente : null;
    }
    /**
     * Set Patente value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $patente
     * @return \Sura\Services\Autoclick\StructType\SiniestralidadModel
     */
    public function setPatente($patente = null)
    {
        // validation for constraint: string
        if (!is_null($patente) && !is_string($patente)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($patente, true), gettype($patente)), __LINE__);
        }
        if (is_null($patente) || (is_array($patente) && empty($patente))) {
            unset($this->Patente);
        } else {
            $this->Patente = $patente;
        }
        return $this;
    }
}
